﻿using FLY.OBJComponents.Client;
using FLY.OBJComponents.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Reflection;
using System.Text;
using System.Windows;

namespace FLY.FeedbackRenZiJia.UI.Client
{
    public class TDGage
    {
        public static TDGage Current { get; } = new TDGage();
        
        
        public FLY.FeedbackRenZiJia.Client.FeedbackHeatServiceClient mFeedback;
        public FLY.FeedbackRenZiJia.Client.HeatBufServiceClient mHeatBuf;
        public FLY.FeedbackRenZiJia.Client.HeatCellServiceClient mHeatCell;
        public FLY.FeedbackRenZiJia.Client.SnapShotBufServiceClient mSnapShotBuf;
        public WarningServiceClient mWarningService;
        public BufferWindow<FlyData_WarningHistory> mWarningReasonWindow;
        
        public FLY.Thick.Blowing.IService.IBlowing mBlowing;
        public FLY.Thick.Blowing.IService.IBlowingDetect mBDetect;
        
        public TDGage()
        {
            mFeedback = new FeedbackRenZiJia.Client.FeedbackHeatServiceClient(OBJ_INTERFACE.OBJ_INTERFACE_ID.FEEDBACK_ID);
            mHeatBuf = new FeedbackRenZiJia.Client.HeatBufServiceClient(OBJ_INTERFACE.OBJ_INTERFACE_ID.HEATBUF_ID);
            mHeatCell = new FeedbackRenZiJia.Client.HeatCellServiceClient(OBJ_INTERFACE.OBJ_INTERFACE_ID.HEATCELL_ID);
            mSnapShotBuf = new FeedbackRenZiJia.Client.SnapShotBufServiceClient(OBJ_INTERFACE.OBJ_INTERFACE_ID.SNAPSHOT_ID);
            
            FObjBase.FObjSys.Current.Connect_to_Another_OBJSys(
                SysParam.Current.ServerEP,
                mFeedback.ID,
                mHeatBuf.ID,
                mHeatCell.ID,
                mSnapShotBuf.ID);

            mWarningService = new WarningServiceClient(OBJ_INTERFACE.OBJ_INTERFACE_ID.WARNING_OBJ_ID);
            FObjBase.FObjSys.Current.Connect_to_Another_OBJSys(
                SysParam.Current.ServerEP,
                mWarningService.GetIDs());

            mWarningReasonWindow = new BufferWindow<FlyData_WarningHistory>(mWarningService.ReasonList, 100);


            //把实例放入Application.Current.Properties
            Application.Current.Properties["IFeedbackHeat"] = mFeedback;
            Application.Current.Properties["IHeatBuf"] = mHeatBuf;
            Application.Current.Properties["IHeatCell"] = mHeatCell;
            Application.Current.Properties["ISnapShotBuf"] = mSnapShotBuf;


            //从Application.Current.Properties获取需要的单例
            mBlowing = Application.Current.Properties["IBlowing"] as FLY.Thick.Blowing.IService.IBlowing;
            mBDetect = Application.Current.Properties["IBlowingDetect"] as FLY.Thick.Blowing.IService.IBlowingDetect;

        }
    }
}
