﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace FLY.FeedbackRenZiJia.IService
{
    interface IHeatCheck
    {
        /// <summary>
        /// 动作使能
        /// </summary>
        bool Enable { get; set; }

        /// <summary>
        /// 有电流， 输入。 需要与外部绑定
        /// </summary>
        bool HasElectricity { get; set; }
        
        /// <summary>
        /// 当前正在检测的加热棒号， 1~88
        /// </summary>
        int CheckNo { get; }
        
        #region 根据电流判断的加热棒状态
        /// <summary>
        /// 坏的加热棒
        /// </summary>
        bool[] Bads { get; }

        /// <summary>
        /// 没加热，也有电流，电路板短路了
        /// </summary>
        bool ShortCircuit { get; }

        /// <summary>
        /// 没有上电, 或者电流计坏了
        /// </summary>
        bool PowerOff { get; }

        /// <summary>
        /// 有加热棒断路了
        /// </summary>
        bool OpenCircuit { get; }
        #endregion

    }
}
