﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace FLY.FeedbackRenZiJia.Server
{

    public interface IPLCLink:INotifyPropertyChanged
    {
        #region 输出
        /// <summary>
        /// 加热通道数
        /// </summary>
        UInt16 ChannelCnt { get; set; }
        /// <summary>
        /// 加热量更新 写
        /// </summary>
        UInt16 HeatUpdate { get; set; }
        /// <summary>
        /// 设置加热量
        /// </summary>
        /// <param name="values"></param>
        void SetHeat(IEnumerable<UInt16> values);

        #endregion

        #region 当前值
        /// <summary>
        /// 当前电流 有没？
        /// </summary>
        bool HasElectricity { get; }
        /// <summary>
        /// 风机是否启动？
        /// </summary>
        bool HasFan { get; }
        /// <summary>
        /// 加热量更新 读
        /// </summary>
        UInt16 HeatUpdate_R { get; }
        #endregion

        #region 状态
        int Errno { get; set; }
        #endregion

    }
}
