﻿using SQLite;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.FeedbackRenZiJia.Server.Model
{

    /// <summary>
    /// 厚度记录
    /// </summary>
    [Table("ThickHeat")]
    public class Db_ThickHeat:IDbBase
    {
        [Key]
        [PropertyIndex(0)]
        public Int64 ID { get; set; }

        /// <summary>
        /// 测量数据开始时间
        /// </summary>
        [PropertyIndex(1)]
        public DateTime Time { get; set; }

        /// <summary>
        /// 测量数据结束时间
        /// </summary>
        [PropertyIndex(2)]
        public DateTime EndTime { get; set; }

        /// <summary>
        /// 旋转方向 是反向
        /// </summary>
        [PropertyIndex(3)]
        public bool IsBackw { get; set; }

        /// <summary>
        /// 旋转1周的时间 min
        /// </summary>
        [PropertyIndex(4)]
        public double RPeriod { get; set; }

        /// <summary>
        /// 旋转次数
        /// </summary>
        [PropertyIndex(5)]
        public int RCnt { get; set; }

        /// <summary>
        /// 复位区号
        /// </summary>
        [PropertyIndex(6)]
        public int OrgBoltNo { get; set; }

        /// <summary>
        /// 旋转角度 °
        /// </summary>
        [PropertyIndex(7)]
        public double RAngle { get; set; }

        /// <summary>
        /// 膜距离 m
        /// </summary>
        [PropertyIndex(8)]
        public double FilmLength { get; set; }

        /// <summary>
        /// 线速度
        /// </summary>
        [PropertyIndex(9)]
        public double FilmVelocity { get; set; }

        /// <summary>
        /// 斜率补偿
        /// </summary>
        [PropertyIndex(10)]
        public double K { get; set; }

        /// <summary>
        /// 1幅数据
        /// </summary>
        [PropertyIndex(11)]
        public string Thicks { get; set; }

        /// <summary>
        /// 分区表
        /// </summary>
        [PropertyIndex(12)]
        public string Boltmap { get; set; }

        /// <summary>
        /// 加热生效
        /// </summary>
        [PropertyIndex(13)]
        public bool IsStable { get; set; }

        /// <summary>
        /// 开始改变加热时间
        /// </summary>
        [PropertyIndex(14)]
        public DateTime HTime { get; set; }



        /// <summary>
        /// 1幅加热数据 % json
        /// </summary>
        [PropertyIndex(15)]
        public string Heats { get; set; }
    }

}
