﻿using FLY.IBC.Client;
using FLY.OBJComponents.Client;
using FLY.OBJComponents.Common;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FLY.IBC.UI.Client
{
    /// <summary>
    /// Page_ErrorTable.xaml 的交互逻辑
    /// </summary>
    public partial class Page_ErrorTable : Page
    {
        FLY.OBJComponents.Client.WarningServiceClient mWarningService;
        FLY.OBJComponents.Client.BufferWindow<FlyData_WarningHistory> mWindow;

        public Page_ErrorTable()
        {
            InitializeComponent();
            Init();
        }


        void Init()
        {
            mWarningService = TDGage.Current.mWarningService;
            mWindow = TDGage.Current.mWarningReasonWindow;
            gridFlows.ItemsSource = mWindow.Record;
        }

        private void button_back_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.GoBack();
        }

        private void button_newest_click(object sender, RoutedEventArgs e)
        {
            NavigationService ns = Application.Current.Properties["NavigationService"] as NavigationService;
            if (ns != null)
            {
                Page_ErrorNewestTable p = new Page_ErrorNewestTable();
               
                ns.Navigate(p);
            }
        }

        private void button_reset_click(object sender, RoutedEventArgs e)
        {
            mWarningService.Reset();
        }
    }
}
