﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FLY.IBC.UI.Server
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        FLY.AppHelper.WindowNotifyIconHelper notifyiconhelper;
        FLY.IBC.Server.TDGage gage;
        FLY.IBC.Server.OBJProxy.OBJProxy objProxy;
        public MainWindow()
        {
            InitializeComponent();

            this.Title = (new Misc.Ver() { SrcType = typeof(MainWindow) }).ToString();

            notifyiconhelper = new AppHelper.WindowNotifyIconHelper(this, this.Title);

            this.Hide();

            FObjBase.PollModule.Current.Start();
            gage = new FLY.IBC.Server.TDGage("Gage1");
            objProxy = new IBC.Server.OBJProxy.OBJProxy(0, gage);

            FLY.OBJComponents.Server.PLCProxySystem plsos =
                gage.mData.PLCos as FLY.OBJComponents.Server.PLCProxySystem;
            grid_plcos.DataContext = plsos;
            grid_plc.DataContext = plsos.PLCs[0];

        }
    }
}
