﻿using FLY.OBJComponents.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FLY.IBC.Common
{
    public static class ERRNOs
    {
        static ERRNOs()
        {
            ERRNO_PLC_DISCONNECTED = new ERRNO() { Code = 255, Descrption = "IBC PLC连接断开" };
            ERRNO_INLETAIR_MOTOR = new ERRNO() { Code = 0, Descrption = "进风变频故障报警" };
            ERRNO_OUTLETAIR_MOTOR = new ERRNO() { Code = 1, Descrption = "出风变频故障报警" };
            ERRNO_INLETAIR_COMM = new ERRNO() { Code = 3, Descrption = "进风变频通讯报警" };
            ERRNO_OUTLETAIR_COMM = new ERRNO() { Code = 4, Descrption = "出风变频通讯报警" };
        }
        #region 报警类型
        /// <summary>
        /// PLC连接断开
        /// </summary>
        public static ERRNO ERRNO_PLC_DISCONNECTED;
        /// <summary>
        /// 进风变频故障报警
        /// </summary>
        public static ERRNO ERRNO_INLETAIR_MOTOR;
        /// <summary>
        /// 出风变频故障报警
        /// </summary>
        public static ERRNO ERRNO_OUTLETAIR_MOTOR;
        /// <summary>
        /// 进风变频通讯报警
        /// </summary>
        public static ERRNO ERRNO_INLETAIR_COMM;
        /// <summary>
        /// 出风变频通讯报警
        /// </summary>
        public static ERRNO ERRNO_OUTLETAIR_COMM;
        
        #endregion


    }
}
