﻿using SQLite;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.IBC.Server.Model
{
    /// <summary>
    /// 折径表
    /// </summary>
    [Table("Width")]
    public class Db_Width: IDbBase
    {
        [Key]
        [PropertyIndex(0)]
        public Int64 ID { get; set; }

        /// <summary>
        /// 开始时间
        /// </summary>
        [PropertyIndex(1)]
        public DateTime Time { get; set; }

        /// <summary>
        /// 折径显示
        ///  单位:mm
        /// </summary>
        [PropertyIndex(2)]
        public double FilmWidth { get; set; }


        /// <summary>
        /// 进风运行频率(Hz)(自动调节)
        /// </summary>
        [PropertyIndex(3)]
        public double InletAirFreq { get; set; }


        /// <summary>
        /// 出风运行频率(Hz)(手动调节)
        /// </summary>
        [PropertyIndex(4)]
        public double OutletAirFreq { get; set; }
    }

}
