﻿using FLY.IBC.Server.Model;
using FLY.IBC.Server.OBJProxy;
using FLY.OBJComponents.Server;
using FLY.OBJComponents.Server.OBJProxy;
using FObjBase;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace FLY.IBC.Server
{
    public class TDGage 
    {
        public string mParamDirectory;//参数目录 m_path;//数据文件的 根目录默认是 Gage1
        public string mName;//名字 如:gage0

        public SysParam mSysParam;
        public IBCSystem mData;

        Model.DbModel mDbModel;
        public Model.HistoryDb mHistoryDb;
        public WarningSystem mWarning;

        public TDGage(string nam)
        {
            mName = nam;
            mParamDirectory = mName;// @"D:\" + m_name;

            if (!System.IO.Directory.Exists(mParamDirectory))
            {
                System.IO.Directory.CreateDirectory(mParamDirectory);
            }
            System.Environment.CurrentDirectory = mParamDirectory;

            Init1();

        }
        #region Init登陆服务器初始化----------------------------------------------------
        /// <summary>
        /// 第1步, 加载本地数据
        /// </summary>
        public void Init1()
        {
            mSysParam = new SysParam();
            mData = new IBCSystem();

            //---------------------------------------------------------------------------------------------------------------
            //数据库
            mDbModel = new DbModel();
            mDbModel.Init();

            mHistoryDb = new HistoryDb();
            mHistoryDb.Init(mDbModel);
            mHistoryDb.KeepDBSize(mSysParam.DBKeepMonth);

            mWarning = new WarningSystem(mHistoryDb.ErrorBuffer);

            mData.Init(mHistoryDb, mWarning);


        }
        


        #endregion

    }
}
