﻿using FLY.OBJComponents.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FLY.IntegratedControl.Common
{
    public static class ERRNOs
    {
        static ERRNOs()
        {
            ERRNO_PLC_DISCONNECTED = new ERRNO() { Code = 255, Descrption = "综合控制 PLC连接断开" };
            ERRNO_INLETAIR_MOTOR = new ERRNO() { Code = 0, Descrption = "进风变频故障报警" };
            ERRNO_OUTLETAIR_MOTOR = new ERRNO() { Code = 1, Descrption = "出风变频故障报警" };
            ERRNO_INLETAIR_COMM = new ERRNO() { Code = 2, Descrption = "进风变频通讯报警" };
            ERRNO_OUTLETAIR_COMM = new ERRNO() { Code = 3, Descrption = "出风变频通讯报警" };

            ERRNO_EXCOOL_MOTOR = new ERRNO() { Code = 4, Descrption = "外冷变频故障报警" };
            ERRNO_ROTATION_MOTOR = new ERRNO() { Code = 5, Descrption = "旋转变频故障报警" };
            ERRNO_TRACTION_MOTOR = new ERRNO() { Code = 6, Descrption = "牵引变频故障报警" };
            ERRNO_EXCOOL_COMM = new ERRNO() { Code = 7, Descrption = "外冷变频通讯报警" };
            ERRNO_ROTATION_COMM = new ERRNO() { Code = 8, Descrption = "旋转变频通讯报警" };
            ERRNO_TRACTION_COMM = new ERRNO() { Code = 9, Descrption = "牵引变频通讯报警" };
            ERRNO_AIR_POWER = new ERRNO() { Code = 10, Descrption = "风机电源报警" };
            ERRNO_EMERGENCY_STOP = new ERRNO() { Code = 11, Descrption = "急停开启报警" };
            ERRNO_ROTATION_FORW_LIMIT = new ERRNO() { Code = 12, Descrption = "旋转正转极限报警" };
            ERRNO_ROTATION_BACKW_LIMIT = new ERRNO() { Code = 13, Descrption = "旋转反转极限报警" };

        }
        #region 报警类型
        /// <summary>
        /// PLC连接断开
        /// </summary>
        public static ERRNO ERRNO_PLC_DISCONNECTED;
        /// <summary>
        /// 进风变频故障报警
        /// </summary>
        public static ERRNO ERRNO_INLETAIR_MOTOR;
        /// <summary>
        /// 出风变频故障报警
        /// </summary>
        public static ERRNO ERRNO_OUTLETAIR_MOTOR;
        /// <summary>
        /// 进风变频通讯报警
        /// </summary>
        public static ERRNO ERRNO_INLETAIR_COMM;
        /// <summary>
        /// 出风变频通讯报警
        /// </summary>
        public static ERRNO ERRNO_OUTLETAIR_COMM;

        /// <summary>
        /// 外冷变频故障报警
        /// </summary>
        public static ERRNO ERRNO_EXCOOL_MOTOR;

        /// <summary>
        /// 旋转变频故障报警 
        /// </summary>
        public static ERRNO ERRNO_ROTATION_MOTOR;


        /// <summary>
        /// 牵引变频故障报警
        /// </summary>
        public static ERRNO ERRNO_TRACTION_MOTOR;

        /// <summary>
        /// 外冷变频通讯报警
        /// </summary>
        public static ERRNO ERRNO_EXCOOL_COMM;

        /// <summary>
        /// 旋转变频通讯报警
        /// </summary>
        public static ERRNO ERRNO_ROTATION_COMM;

        /// <summary>
        /// 牵引变频通讯报警
        /// </summary>
        public static ERRNO ERRNO_TRACTION_COMM;

        /// <summary>
        /// 风机电源报警 
        /// </summary>
        public static ERRNO ERRNO_AIR_POWER;

        /// <summary>
        /// 急停开启报警 
        /// </summary>
        public static ERRNO ERRNO_EMERGENCY_STOP;

        /// <summary>
        /// 旋转正转极限报警
        /// </summary>
        public static ERRNO ERRNO_ROTATION_FORW_LIMIT;

        /// <summary>
        /// 旋转反转极限报警
        /// </summary>
        public static ERRNO ERRNO_ROTATION_BACKW_LIMIT;

        #endregion


    }
}
