﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Navigation;
using System.Windows.Media.Animation;

using Misc;

using FLY.Thick.Base.IService;
using FLY.Thick.Base.Client;
using FLY.Thick.Base.Common;
using System.Globalization;
using System.Threading;
using ThickTcpUiInWindow;
using System.Threading.Tasks;
using System.ComponentModel;

namespace FLY.Thick.Blowing.UI.Fix.Client
{
    /// <summary>
    /// Window1.xaml 的交互逻辑
    /// </summary>、
    public partial class MainWindow : NavigationWindow
    {
        #region 延时推送 MARKNO
        const int MARKNO_WARNING_RING = 1;
        #endregion

        TDGage gage;

        public MainWindow()
        {
            InitializeComponent();

            NavigationCommands.BrowseBack.InputGestures.Add(new KeyGesture(Key.Escape));
        }


        void mSysParam_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            SysParam sysparam = sender as SysParam;
            if (e.PropertyName == "HaveOSK")
            {
                FLY.UI.OSK.KeyboardBehavior.Enable = sysparam.HaveOSK;
            }
            else if (e.PropertyName == "HaveOSK_mouse") 
            {
                FLY.UI.OSK.KeyboardBehavior.EnableMouseDown = sysparam.HaveOSK_mouse;
            }
            else if (e.PropertyName == "Language")
            {
                UpdateCulture();
            }
        }

        LoadingProgress lp;
        PgMain pMain;
        async Task Init()
        {
            //---------------------------------------------------------
            // 创建 与服务器端 连接 
            gage = new TDGage();
            gage.mSysParam.Load();
            gage.mSysParam.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(mSysParam_PropertyChanged);
            FLY.UI.OSK.KeyboardBehavior.Enable = gage.mSysParam.HaveOSK;
            FLY.UI.OSK.KeyboardBehavior.EnableMouseDown = gage.mSysParam.HaveOSK_mouse;
            UpdateCulture();

            gage.Init2();
            //客户端，通过 LCUS 报警！！！！！
            gage.mWarningService.PropertyChanged += (s, e) =>
            {
                if (e.PropertyName == "IsRinging")
                {
                    if ((gage.mSysParam as SysParam).EnableLCUS1)
                    {
                        if (gage.mWarningService.IsRinging)
                        {
                            gage.mLCUS.On();
                        }
                        else
                        {
                            gage.mLCUS.Off();
                        }
                    }
                }
            };

           
            Application.Current.Properties["ThickGage"] = gage;
            Application.Current.Properties["Password"] = gage.mPasswordService;
            Application.Current.Properties["NavigationService"] = NavigationService;

            Application.Current.Properties["DynArea"] = gage.mDynArea;
            Application.Current.Properties["IBlowing"] = gage.mRenZiJiaService;
            Application.Current.Properties["IBlowingDetect"] = gage.mBDetect;
            

            Application.Current.Properties["WindowSize"] = gage.mSysParam.WindowSize;
            //添加观察者，1分钟查一次WindowSize，修改了，就保存
            FObjBase.PollModule.Current.Poll_Config(FObjBase.PollModule.POLL_CONFIG.ADD, () =>
            {
                if (Application.Current.Properties["WindowSize"] is int)
                {
                    if ((int)Application.Current.Properties["WindowSize"] != gage.mSysParam.WindowSize)
                    {
                        gage.mSysParam.WindowSize = (int)Application.Current.Properties["WindowSize"];
                        gage.mSysParam.Save();
                    }
                }
            }, TimeSpan.FromMinutes(1));


            lp.Progress += 10;
            await Task.Delay(10);


            //启动 OnPoll 系统
            FObjBase.PollModule.Current.Start();

            lp.Progress += 10;
            await Task.Delay(10);
        }



        private async void NavigationWindow_Loaded(object sender, RoutedEventArgs e)
        {
            lp = new LoadingProgress();
            Application.Current.Properties["LoadingProgress"] = lp;
            
            //---------------------------------------------------------
            //转到进度条页面
            Page_Loading p = new Page_Loading();
            p.DataContext = lp;
            NavigationService.Navigate(p);

            //---------------------------------------------------------
            //初始化
            await Init();

            //---------------------------------------------------------
            //转到主界面
            pMain = new PgMain();
            await pMain.Init(gage);
            NavigationService.Navigate(pMain);
            pMain.Loaded += (s, e1) =>
            {
                NavigationService.RemoveBackEntry();
            };
        }
        private void UpdateCulture()
        {
            CultureInfo info;
            if (gage.mSysParam.Language == "en-US")
            {
                info = new CultureInfo(gage.mSysParam.Language);
            }
            else
            {
                info = new CultureInfo("zh-CN");
            }
            if (CultureInfo.CurrentCulture.EnglishName == info.EnglishName)
                return;

            Thread.CurrentThread.CurrentCulture = info;
            Thread.CurrentThread.CurrentUICulture = info;

            ThickTcpUiInWindow.App.UpdateCulture(@"Culture/StringResource.");
            ThickTcpUiInWindow.App.UpdateCulture(@"/ThickTcpUiInWindow;component/Culture/StringResource.");
        }
    }
    //public class ApplicationPropertyChanged : INotifyPropertyChanged
    //{
    //    public event PropertyChangedEventHandler PropertyChanged;
    //    public void Notify(string perpertyName)
    //    {

    //    }
    //}
}
