﻿using FLY.Thick.Blowing.IService;
using LiveCharts;
using LiveCharts.Configurations;
using LiveCharts.Wpf;
using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FLY.Thick.Blowing.UI.Fix.Client
{
    /// <summary>
    /// PgBlowingExt.xaml 的交互逻辑
    /// </summary>
    public partial class PgBlowingExt : Page
    {
        PgBlowingExtVm viewModel;

        public PgBlowingExt()
        {
            InitializeComponent();
        }
        public void Init(IBlowingFixService blowing, IBlowingDetect rdetect)
        {
            viewModel = new PgBlowingExtVm();

            viewModel.Init(blowing, rdetect);
            this.DataContext = viewModel;
            
        }
        
    }


    public class LimitList2SectionsConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var LimitSections = new SectionsCollection();
            List<TimeValue> limits = value as List<TimeValue>;
            if (limits != null)
            { 
                foreach (var tv in limits)
                {
                    LimitSections.Add(new AxisSection()
                    {
                        Value = tv.Time.Ticks,
                        SectionWidth = 1,
                        Fill = new SolidColorBrush((Color)ColorConverter.ConvertFromString("#59FF5722")),
                        Stroke = new SolidColorBrush((Color)ColorConverter.ConvertFromString("#ff5722")),
                        StrokeThickness = 0.5,
                        DataLabelForeground = new SolidColorBrush((Color)ColorConverter.ConvertFromString("White")),
                        DataLabel = true,
                        DisableAnimations = true
                    });
                }
            }
            return LimitSections;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
