﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FLY.Thick.BulkDataModule;
using FLY.Thick.Base.Server.OBJProxy;
using FLY.Thick.Blowing.OBJ_INTERFACE;

namespace FLY.Thick.Blowing.Server.OBJProxy
{
    public class OBJProxy
    {
        BulkDataService_OBJProxy mBulkDataOBJProxy;
        Curve_OBJProxy mCurveOBJProxy;
        DynArea_OBJProxy mDynAreaOBJProxy;
        FlyAD_OBJProxy mFlyADOBJProxy;
        Fix_OBJProxy mFixOBJProxy;
        FLY.OBJComponents.Server.OBJProxy.WarningSystem_OBJProxy mWarnSystemOBJProxy;
        BlowingFixProfile_OBJProxy mProfileOBJProxy;
        Password_OBJProxy mPasswordOBJProxy;
        Initparam_OBJProxy mInitparamOBJProxy;

        BlowingFix_OBJProxy mBlowingOBJProxy;
        BlowingDetect_OBJProxy mBDetectOBJProxy;
        ScanWarning_OBJProxy mScanWarningOBJProxy;
        BulkDB_OBJProxy mBulkDBOBJProxy;

        public OBJProxy(int objsys_idx, TDGage gage)
        {
            TDGage mGage = gage;
            mBulkDataOBJProxy = new BulkDataService_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.BULK_ID, mGage.mBulk);

            mProfileOBJProxy = new BlowingFixProfile_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.BFPROFILE_ID, mGage.mProfile);

            mCurveOBJProxy = new Curve_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.CURVE_ID, mGage.mCurve);

            mDynAreaOBJProxy = new DynArea_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.DYNAREA_ID, mGage.mDynArea);

            mFlyADOBJProxy = new FlyAD_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.FLYAD_ID, mGage.mFlyAD, mGage.AD2Thick);

            mFixOBJProxy = new Fix_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.FIX_ID, mGage.mGMFix);

            mWarnSystemOBJProxy = new FLY.OBJComponents.Server.OBJProxy.WarningSystem_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.WARNING_OBJ_ID, mGage.mWarning);

            mPasswordOBJProxy = new Password_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.PASSWORD_ID, mGage.mPassword);

            mInitparamOBJProxy = new Initparam_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.INITPARAM_ID, mGage.mInitParam);

            mBlowingOBJProxy = new BlowingFix_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.RENZIJIA_ID, mGage.mGMRenZiJiaFix);

            mBDetectOBJProxy = new BlowingDetect_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.BDETECT_ID, mGage.mGMRenZiJiaFix.mPDetect);

            mScanWarningOBJProxy = new ScanWarning_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.SCANWARNING_ID, mGage.mScanWarning);

            mBulkDBOBJProxy = new BulkDB_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.BULKDB_ID, mGage.mBulkDb);
            

            mBlowingOBJProxy.CurrObjSys.Start_Conn_Server(
                mGage.mSysParam.LocalEP,
                mBulkDataOBJProxy.ID);
        }
    }
}
