﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Thick.Blowing.Server.Model
{
    /// <summary>
    /// 正在生产的数据，或之前生产完的数据
    /// </summary>
    public class LocalDb : INotifyPropertyChanged
    {
        public Db_Profile CurrProfile;

        /// <summary>
        /// 当前生产，开始产生数据时间
        /// </summary>
        public DateTime ProfileStartTime { get; set; }

        /// <summary>
        /// 当前生产，最后产生数据时间
        /// </summary>
        public DateTime ProfileEndTime { get; set; }

        /// <summary>
        /// 当前生产，已经结束，已经下辊了
        /// </summary>
        public bool IsProfileFinished { get; set; }

        public LocalDb()
        {
            Init();
        }
        void Init()
        {
            CurrProfile = null;
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
