﻿using SQLite;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Thick.Blowing.Server.Model
{
    /// <summary>
    /// 信号记录
    /// </summary>
    [Table("Sign")]
    public class Db_Sign
    {
        /// <summary>
        /// key
        /// </summary>
        [Key]
        [PropertyIndex(0)]
        public Int64 ID { get; set; }

        /// <summary>
        /// 信号时间
        /// </summary>
        [PropertyIndex(1)]
        public DateTime Time { get; set; }

        /// <summary>
        /// 信号列表 SignData[]
        /// </summary>
        [PropertyIndex(2)]
        public string Signs { get; set; }
    }


    /// <summary>
    /// 辊信号记录
    /// </summary>
    [Table("Roll")]
    public class Db_Roll
    {
        /// <summary>
        /// key
        /// </summary>
        [Key]
        [PropertyIndex(0)]
        public Int64 ID { get; set; }

        /// <summary>
        /// 开始时间
        /// </summary>
        [PropertyIndex(1)]
        public DateTime Time { get; set; }

        /// <summary>
        /// 信号列表 RollCell[]
        /// </summary>
        [PropertyIndex(2)]
        public string Signs { get; set; }
    }

}
