﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Navigation;
using System.Windows.Media.Animation;

using Misc;

using FLY.Thick.Base.IService;
using FLY.Thick.Base.Client;
using FLY.Thick.Base.Common;
using System.Threading;
using ThickTcpUiInWindow;
using System.Globalization;
using System.Threading.Tasks;

namespace FLY.Thick.BlowingScan.UI.Client
{
    /// <summary>
    /// Window1.xaml 的交互逻辑
    /// </summary>、
    public partial class MainWindow : NavigationWindow
    {
        #region 延时推送 MARKNO
        const int MARKNO_WARNING_RING = 1;
        #endregion

        TDGage gage;

        public MainWindow()
        {
            InitializeComponent();

            NavigationCommands.BrowseBack.InputGestures.Add(new KeyGesture(Key.Escape));
        }
        int autoscan_tip_id=-1;
         void mSysParam_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            SysParam sysparam = sender as SysParam;
            if (e.PropertyName == "HaveOSK")
            {
                FLY.UI.OSK.KeyboardBehavior.Enable = sysparam.HaveOSK;
            }
            else if (e.PropertyName == "HaveOSK_mouse")
            {
                FLY.UI.OSK.KeyboardBehavior.EnableMouseDown = sysparam.HaveOSK_mouse;
            }
            else if (e.PropertyName == "Language")
            {
                UpdateCulture();
            }
        }


        LoadingProgress lp;
        PgMain pMain;
        async Task Init() 
        {
            //---------------------------------------------------------
            // 创建 与服务器端 连接 
            gage = new TDGage();
            gage.mSysParam.Load();
            gage.mSysParam.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(mSysParam_PropertyChanged);
            FLY.UI.OSK.KeyboardBehavior.Enable = gage.mSysParam.HaveOSK;
            FLY.UI.OSK.KeyboardBehavior.EnableMouseDown = gage.mSysParam.HaveOSK_mouse;

            UpdateCulture();


            gage.Init2();
            //客户端，通过 LCUS 报警！！！！！
            gage.mWarningService.PropertyChanged += (s, e) =>
            {
                if (e.PropertyName == "IsRinging")
                {
                    if ((gage.mSysParam as SysParam).EnableLCUS1)
                    {
                        if (gage.mWarningService.IsRinging)
                        {
                            gage.mLCUS.On();
                        }
                        else
                        {
                            gage.mLCUS.Off();
                        }
                    }
                }
            };

            Application.Current.Properties["ThickGage"]= gage;
            Application.Current.Properties["Password"] = gage.mPasswordService;
            Application.Current.Properties["NavigationService"]= NavigationService;

            Application.Current.Properties["DynArea"] = gage.mDynArea;
            Application.Current.Properties["IBlowing"] = gage.mRenZiJiaService;
            Application.Current.Properties["IBlowingDetect"] = gage.mBDetect;


            Application.Current.Properties["WindowSize"] = gage.mSysParam.WindowSize;
            //添加观察者，1分钟查一次WindowSize，修改了，就保存
            FObjBase.PollModule.Current.Poll_Config(FObjBase.PollModule.POLL_CONFIG.ADD, () =>
            {
                if (Application.Current.Properties["WindowSize"] is int)
                {
                    if ((int)Application.Current.Properties["WindowSize"] != gage.mSysParam.WindowSize)
                    {
                        gage.mSysParam.WindowSize = (int)Application.Current.Properties["WindowSize"];
                        gage.mSysParam.Save();
                    }
                }
            }, TimeSpan.FromMinutes(1));


            gage.mDynArea.PropertyChanged += (s, e) =>
            {
                DynArea dynarea = s as DynArea;
                //if (e.PropertyName == "Hrs") //不需要在这里提示了， 时间不够，已经变成了一个报警。
                //{

                //    if (gage.mDynArea.Hrs < 48) 
                //    {
                //        FLY.ControlLibrary.Window_WarningTip.Show(
                //            "警告",
                //            "设备剩余时间 " + gage.mDynArea.Hrs + "小时，请联系枫莱尔公司",
                //            TimeSpan.FromSeconds(gage.mSysParam.WarningTipDuration),
                //            gage.mSysParam.WarningTipPath);
                //    }
                //}
                if (e.PropertyName == "ControllerState")
                {
                    if (gage.mDynArea.ControllerState != CTRL_STATE.AUTOSCAN)
                    {
                        if (autoscan_tip_id != -1)
                        {
                            FLY.ControlLibrary.Window_WarningTip.Stop(autoscan_tip_id);
                            autoscan_tip_id = -1;
                        }
                    }

                    if (gage.mDynArea.ControllerState == CTRL_STATE.PAUSE)
                    {
                        FLY.ControlLibrary.Window_WarningTip.Show(
                            "通知",
                            "暂停扫描",
                            TimeSpan.MaxValue);
                    }



                    //case CTRL_STATE.AUTOSCAN://这些不是报警！！！
                    //    FLY.ControlLibrary.Window_WarningTip.Show(
                    //        "通知",

                    //        gage.mDynArea.AutoScanCounter + "秒后，开始扫描",
                    //        TimeSpan.MaxValue,
                    //        gage.mSysParam.WarningTipPath);
                    //    break;

                }
                else if (e.PropertyName == "AutoScanCounter")
                {
                    if (gage.mDynArea.ControllerState == CTRL_STATE.AUTOSCAN)
                    {
                        autoscan_tip_id = FLY.ControlLibrary.Window_WarningTip.Show(
                            "通知",
                            gage.mDynArea.AutoScanCounter.ToString() + "秒后，开始扫描",
                            TimeSpan.FromSeconds(gage.mDynArea.AutoScanCounter),
                            null,
                            gage.mWarningService.Reset,
                            "取消",
                            new Action(delegate()
                        {
                            gage.mTDGageService.StartP2(STARTP2_MODE.STOP);
                        })
                            );
                    }
                }

            };
            lp.Progress += 10;
            await Task.Delay(10);

            
            FObjBase.PollModule.Current.Start();
            lp.Progress += 10;
            await Task.Delay(10);
        }

        private async void NavigationWindow_Loaded(object sender, RoutedEventArgs e)
        {
            lp = new LoadingProgress();
            Application.Current.Properties.Add("LoadingProgress", lp);

            //---------------------------------------------------------
            //转到进度条页面
            Page_Loading p = new Page_Loading();
            p.DataContext = lp;
            NavigationService.Navigate(p);


            //---------------------------------------------------------
            //初始化
            await Init();

            //---------------------------------------------------------
            //转到主界面
            pMain = new PgMain();
            
            await pMain.Init(gage);

            NavigationService.Navigate(pMain);
            pMain.Loaded += (s, e1) =>
            {
                NavigationService.RemoveBackEntry();
            };
        }


        private void UpdateCulture()
        {
            CultureInfo info;
            if (gage.mSysParam.Language == "en-US")
            {
                info = new CultureInfo(gage.mSysParam.Language);
            }
            else
            {
                info = new CultureInfo("zh-CN");
            }
            if (CultureInfo.CurrentCulture.EnglishName == info.EnglishName)
                return;

            Thread.CurrentThread.CurrentCulture = info;
            Thread.CurrentThread.CurrentUICulture = info;

            ThickTcpUiInWindow.App.UpdateCulture(@"Culture/StringResource.");
            ThickTcpUiInWindow.App.UpdateCulture(@"/ThickTcpUiInWindow;component/Culture/StringResource.");
        }

        private void CommandBindingScan_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            
                if (gage.mDynArea.SecuteLock)
                {
                    FLY.ControlLibrary.Window_WarningTip.Show(
                        "警告",
                        "使用码到期，请联系枫莱尔公司",
                        TimeSpan.FromSeconds(5),
                        gage.mSysParam.WarningTipPath);
                }
                else {
                    gage.mTDGageService.StartP1();
                }
            
        }
        private void CommandBindingStop_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            gage.mTDGageService.StartP2(STARTP2_MODE.STOP);
        }
        private void CommandBindingForw_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            gage.mTDGageService.StartP2(STARTP2_MODE.FORW);
        }
        private void CommandBindingBackw_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            gage.mTDGageService.StartP2(STARTP2_MODE.BACKW);
        }
        private void CommandBindingOrg_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            gage.mTDGageService.StartP2(STARTP2_MODE.ORG);
        }
    }
    public static class GageCommands
    {
        static GageCommands()
        {
            scan.InputGestures.Add(new KeyGesture(Key.F1));
            org.InputGestures.Add(new KeyGesture(Key.F2));
            stop.InputGestures.Add(new KeyGesture(Key.F3));
            forward.InputGestures.Add(new KeyGesture(Key.F4));
            backward.InputGestures.Add(new KeyGesture(Key.F5));
        }
        private static RoutedUICommand scan = new RoutedUICommand("SCAN", "Scan", typeof(GageCommands));
        public static RoutedUICommand Scan { get { return scan; } }

        private static RoutedCommand org = new RoutedCommand("Org", typeof(GageCommands));
        public static RoutedCommand Org { get { return org; } }

        private static RoutedCommand stop = new RoutedCommand("Stop", typeof(GageCommands));
        public static RoutedCommand Stop { get { return stop; } }

        private static RoutedCommand forward = new RoutedCommand("Forward", typeof(GageCommands));
        public static RoutedCommand Forward { get { return forward; } }

        private static RoutedCommand backward = new RoutedCommand("Backward", typeof(GageCommands));
        public static RoutedCommand Backward { get { return backward; } }
    }
}
