﻿using FLY.Thick.Base.Client;
using FLY.Thick.Blowing.Client;
using FLY.Thick.BlowingScan.Client;
using FLY.Thick.BlowingScan.Common;
using FLY.Thick.BlowingScan.IService;
using Misc;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Forms.DataVisualization.Charting;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using ThickTcpUiInWindow;

namespace FLY.Thick.BlowingScan.UI.Client
{ 
    /// <summary>
    /// Page_BufList.xaml 的交互逻辑
    /// </summary>
    public partial class PgBufList : Page,INotifyPropertyChanged
    {
        BorderSearchServiceClient mBorderSearch;
        BlowingScanServiceClient mRenZiJia;
        BlowingDetectServiceClient mBDetect;
        BlowingScanAnaylze mAnaylze;
        Dictionary<MarkData, Chart> powerchart = new Dictionary<MarkData, Chart>();
        Dictionary<MarkData, Chart> avgchart = new Dictionary<MarkData, Chart>();
        Dictionary<MarkData, Chart> orgchart = new Dictionary<MarkData, Chart>();
        Dictionary<MarkData, Series> solveSeries = new Dictionary<MarkData, Series>();

        ProgressTimer ptimer = new ProgressTimer();

        /// <summary>
        /// 数据加载中
        /// </summary>
        public bool IsBufListLoading { get; set; }


        /// <summary>
        /// 工作中
        /// </summary>
        public bool IsRunning { get; set; }

        public PgBufList()
        {
            InitializeComponent();
            InitializeChart_solve();

            InitializeChart_org(chart10, System.Drawing.Color.FromArgb(((int)(((byte)(220)))), ((int)(((byte)(65)))), ((int)(((byte)(140)))), ((int)(((byte)(240))))));
            InitializeChart_avg(chart11, System.Drawing.Color.FromArgb(((int)(((byte)(220)))), ((int)(((byte)(65)))), ((int)(((byte)(140)))), ((int)(((byte)(240))))));
            InitializeChart_bolts(chart12, System.Drawing.Color.FromArgb(((int)(((byte)(220)))), ((int)(((byte)(65)))), ((int)(((byte)(140)))), ((int)(((byte)(240))))));

            InitializeChart_org(chart20, System.Drawing.Color.HotPink);
            InitializeChart_avg(chart21, System.Drawing.Color.HotPink);
            InitializeChart_bolts(chart22, System.Drawing.Color.HotPink);

            InitializeChart_gage(chart3, System.Drawing.Color.Blue);

            this.button_download.DataContext = this;
            
        }
        /// <summary>
        /// 解方程图
        /// </summary>
        void InitializeChart_solve()
        {
            ChartArea chartArea1 = new ChartArea();

            Legend legend1 = new Legend();

            Series series1 = new Series();
            Series series2 = new Series();

            Chart chart1 = this.chart1;
            // 
            // chart1
            // 
            //this.chart1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(211)), ((System.Byte)(223)), ((System.Byte)(240)));
            //this.chart1.BackSecondaryColor = System.Drawing.Color.White;
            //this.chart1.BackGradientStyle = System.Windows.Forms.DataVisualization.Charting.GradientStyle.TopBottom;
            //this.chart1.BorderlineColor = System.Drawing.Color.FromArgb(((System.Byte)(26)), ((System.Byte)(59)), ((System.Byte)(105)));
            //this.chart1.BorderlineDashStyle = System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid;
            //this.chart1.BorderlineWidth = 2;
            //this.chart1.BorderSkin.SkinStyle = System.Windows.Forms.DataVisualization.Charting.BorderSkinStyle.Emboss;


            #region chartArea
            #region chartArea1
            chartArea1.Name = "chartArea1";

            chartArea1.AxisX.IsLabelAutoFit = false;
            chartArea1.AxisX.LabelStyle.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            chartArea1.AxisX.LabelStyle.IsEndLabelVisible = false;
            chartArea1.AxisX.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisX.MajorGrid.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisX.Interval = 5;

            chartArea1.AxisY.IsLabelAutoFit = true;
            chartArea1.AxisY.LabelStyle.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            chartArea1.AxisY.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisY.MajorGrid.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisY.IsStartedFromZero = true;
            chartArea1.AxisY.IntervalAutoMode = IntervalAutoMode.FixedCount;
            chartArea1.AxisY.LabelAutoFitStyle = LabelAutoFitStyles.DecreaseFont;
            //chartArea1.AxisY.Title = "厚度(%)";

            //chartArea1.AxisY.Maximum = 100;
            //chartArea1.AxisY.Minimum = 0;
            //chartArea1.AxisY.Interval = 10;

            chartArea1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(165)), ((System.Byte)(191)), ((System.Byte)(228)));
            chartArea1.BackSecondaryColor = System.Drawing.Color.White;
            chartArea1.BackGradientStyle = System.Windows.Forms.DataVisualization.Charting.GradientStyle.TopBottom;
            chartArea1.BorderColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.BorderDashStyle = System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid;

            chartArea1.Position.Auto = false;// true;
            chartArea1.Position.Height = 100F;
            chartArea1.Position.Width = 100F;
            chartArea1.Position.X = 0;
            chartArea1.Position.Y = 0;
            chartArea1.ShadowColor = System.Drawing.Color.Transparent;


            #endregion

            chart1.ChartAreas.Add(chartArea1);
            #endregion

            #region legend
            #region legend1
            legend1.Name = "legend1";
            legend1.Alignment = System.Drawing.StringAlignment.Near;
            legend1.IsTextAutoFit = false;
            legend1.BackColor = System.Drawing.Color.Transparent;
            legend1.Docking = Docking.Right;
            legend1.IsDockedInsideChartArea = true;
            legend1.DockedToChartArea = chartArea1.Name;
            legend1.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            legend1.LegendStyle = LegendStyle.Column;

            legend1.Position.Auto = true;

            #endregion

            chart1.Legends.Add(legend1);
            #endregion

            #region series
            #region series1
            series1.Name = "series1";
            series1.BorderColor = System.Drawing.Color.FromArgb(((System.Byte)(180)), ((System.Byte)(26)), ((System.Byte)(59)), ((System.Byte)(105)));
            series1.BorderWidth = 2;
            series1.ChartArea = chartArea1.Name;
            series1.ChartType = SeriesChartType.Line;
            series1.Color = System.Drawing.Color.FromArgb(((int)(((byte)(220)))), ((int)(((byte)(65)))), ((int)(((byte)(140)))), ((int)(((byte)(240)))));

            series1.XValueType = ChartValueType.Int32;
            series1.YValueType = ChartValueType.Int32;

            series1.ShadowColor = System.Drawing.Color.Black;
            series1.ShadowOffset = 2;

            series1.IsVisibleInLegend = true;
            series1.Legend = legend1.Name;
            series1.LegendText = "记录1";
            #endregion

            #region series2
            series2.Name = "series2";
            series2.BorderColor = System.Drawing.Color.Red;
            series2.BorderWidth = 2;
            series2.ChartArea = chartArea1.Name;
            series2.ChartType = SeriesChartType.Line;
            series2.Color = System.Drawing.Color.HotPink;

            series2.XValueType = ChartValueType.Int32;
            series2.YValueType = ChartValueType.Int32;

            series2.ShadowColor = System.Drawing.Color.Black;
            series2.ShadowOffset = 2;

            series2.IsVisibleInLegend = true;
            series2.Legend = legend1.Name;
            series2.LegendText = "记录2";
            #endregion


            chart1.Series.Add(series1);
            chart1.Series.Add(series2);

            #endregion

            chart1.Name = "chart1";
            chart1.Palette = System.Windows.Forms.DataVisualization.Charting.ChartColorPalette.BrightPastel;
            chart1.Location = new System.Drawing.Point(0, 0);

            //??????????????????????????????????????
            //((System.ComponentModel.ISupportInitialize)(this.chart1)).EndInit();

        }

        /// <summary>
        /// 扫描图
        /// </summary>
        /// <param name="chart1"></param>
        void InitializeChart_gage(Chart chart1, System.Drawing.Color series_color)
        {
            ChartArea chartArea1 = new ChartArea();

            Legend legend1 = new Legend();

            Series series1 = new Series();
            // 
            // chart1
            // 
            //this.chart1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(211)), ((System.Byte)(223)), ((System.Byte)(240)));
            //this.chart1.BackSecondaryColor = System.Drawing.Color.White;
            //this.chart1.BackGradientStyle = System.Windows.Forms.DataVisualization.Charting.GradientStyle.TopBottom;
            //this.chart1.BorderlineColor = System.Drawing.Color.FromArgb(((System.Byte)(26)), ((System.Byte)(59)), ((System.Byte)(105)));
            //this.chart1.BorderlineDashStyle = System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid;
            //this.chart1.BorderlineWidth = 2;
            //this.chart1.BorderSkin.SkinStyle = System.Windows.Forms.DataVisualization.Charting.BorderSkinStyle.Emboss;


            #region chartArea
            #region chartArea1
            chartArea1.Name = "chartArea1";

            chartArea1.AxisX.IsLabelAutoFit = true;
            chartArea1.AxisX.LabelStyle.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            chartArea1.AxisX.LabelStyle.IsEndLabelVisible = true;
            chartArea1.AxisY.IsStartedFromZero = true;
            chartArea1.AxisX.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisX.MajorGrid.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisX.IntervalAutoMode = IntervalAutoMode.FixedCount;
            chartArea1.AxisX.LabelAutoFitStyle = LabelAutoFitStyles.DecreaseFont;
            //chartArea1.AxisX.Interval = 5;

            chartArea1.AxisY.IsLabelAutoFit = true;
            chartArea1.AxisY.LabelStyle.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            chartArea1.AxisY.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisY.MajorGrid.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisY.IsStartedFromZero = true;
            chartArea1.AxisY.IntervalAutoMode = IntervalAutoMode.FixedCount;
            chartArea1.AxisY.LabelAutoFitStyle = LabelAutoFitStyles.DecreaseFont;
            chartArea1.AxisY.Title = "厚度";

            //chartArea1.AxisY.Maximum = 100;
            //chartArea1.AxisY.Minimum = 0;
            //chartArea1.AxisY.Interval = 10;

            chartArea1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(165)), ((System.Byte)(191)), ((System.Byte)(228)));
            chartArea1.BackSecondaryColor = System.Drawing.Color.White;
            chartArea1.BackGradientStyle = System.Windows.Forms.DataVisualization.Charting.GradientStyle.TopBottom;
            chartArea1.BorderColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.BorderDashStyle = System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid;

            chartArea1.Position.Auto = false;// true;
            chartArea1.Position.Height = 100F;
            chartArea1.Position.Width = 100F;
            chartArea1.Position.X = 0;
            chartArea1.Position.Y = 0;
            chartArea1.ShadowColor = System.Drawing.Color.Transparent;


            //chartArea1.CursorX.IsUserEnabled = true;
            //chartArea1.CursorX.IsUserSelectionEnabled = true;
            //chartArea1.CursorX.SelectionColor = System.Drawing.SystemColors.Highlight;

            chartArea1.CursorY.IsUserEnabled = true;
            chartArea1.CursorY.IsUserSelectionEnabled = true;
            chartArea1.CursorY.SelectionColor = System.Drawing.SystemColors.Highlight;

            #endregion

            chart1.ChartAreas.Add(chartArea1);
            #endregion

            #region legend
            #region legend1
            legend1.Name = "legend1";
            legend1.Alignment = System.Drawing.StringAlignment.Near;
            legend1.IsTextAutoFit = false;
            legend1.BackColor = System.Drawing.Color.Transparent;
            legend1.Docking = Docking.Right;
            legend1.IsDockedInsideChartArea = true;
            legend1.DockedToChartArea = chartArea1.Name;
            legend1.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            legend1.LegendStyle = LegendStyle.Column;

            legend1.Position.Auto = true;

            #endregion

            chart1.Legends.Add(legend1);
            #endregion

            #region series
            #region series1
            series1.Name = "series1";
            series1.BorderColor = series_color;
            series1.BorderWidth = 2;
            series1.ChartArea = chartArea1.Name;
            series1.ChartType = SeriesChartType.Line;
            series1.Color = series_color;


            series1.XValueType = ChartValueType.Int32;
            series1.YValueType = ChartValueType.Double;

            series1.ShadowColor = System.Drawing.Color.Black;
            series1.ShadowOffset = 2;

            series1.IsVisibleInLegend = true;
            series1.Legend = legend1.Name;
            series1.LegendText = "全部扫描均值";
            #endregion


            chart1.Series.Add(series1);
            #endregion

            chart1.Name = "chart1";
            chart1.Palette = System.Windows.Forms.DataVisualization.Charting.ChartColorPalette.BrightPastel;
            chart1.Location = new System.Drawing.Point(0, 0);

            //??????????????????????????????????????
            //((System.ComponentModel.ISupportInitialize)(this.chart1)).EndInit();

        }
        /// <summary>
        /// 扫描图
        /// </summary>
        /// <param name="chart1"></param>
        void InitializeChart_org(Chart chart1,System.Drawing.Color series_color)
        {
            ChartArea chartArea1 = new ChartArea();

            Legend legend1 = new Legend();

            Series series1 = new Series();
            Series series2 = new Series();
            // 
            // chart1
            // 
            //this.chart1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(211)), ((System.Byte)(223)), ((System.Byte)(240)));
            //this.chart1.BackSecondaryColor = System.Drawing.Color.White;
            //this.chart1.BackGradientStyle = System.Windows.Forms.DataVisualization.Charting.GradientStyle.TopBottom;
            //this.chart1.BorderlineColor = System.Drawing.Color.FromArgb(((System.Byte)(26)), ((System.Byte)(59)), ((System.Byte)(105)));
            //this.chart1.BorderlineDashStyle = System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid;
            //this.chart1.BorderlineWidth = 2;
            //this.chart1.BorderSkin.SkinStyle = System.Windows.Forms.DataVisualization.Charting.BorderSkinStyle.Emboss;


            #region chartArea
            #region chartArea1
            chartArea1.Name = "chartArea1";

            chartArea1.AxisX.IsLabelAutoFit = true;
            chartArea1.AxisX.LabelStyle.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            chartArea1.AxisX.LabelStyle.IsEndLabelVisible = true;
            chartArea1.AxisY.IsStartedFromZero = true;
            chartArea1.AxisX.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisX.MajorGrid.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisX.IntervalAutoMode = IntervalAutoMode.FixedCount;
            chartArea1.AxisX.LabelAutoFitStyle = LabelAutoFitStyles.DecreaseFont;
            //chartArea1.AxisX.Interval = 5;

            chartArea1.AxisY.IsLabelAutoFit = true;
            chartArea1.AxisY.LabelStyle.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            chartArea1.AxisY.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisY.MajorGrid.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisY.IsStartedFromZero = true;
            chartArea1.AxisY.IntervalAutoMode = IntervalAutoMode.FixedCount;
            chartArea1.AxisY.LabelAutoFitStyle = LabelAutoFitStyles.DecreaseFont;
            chartArea1.AxisY.Title = "厚度";

            //chartArea1.AxisY.Maximum = 100;
            //chartArea1.AxisY.Minimum = 0;
            //chartArea1.AxisY.Interval = 10;

            chartArea1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(165)), ((System.Byte)(191)), ((System.Byte)(228)));
            chartArea1.BackSecondaryColor = System.Drawing.Color.White;
            chartArea1.BackGradientStyle = System.Windows.Forms.DataVisualization.Charting.GradientStyle.TopBottom;
            chartArea1.BorderColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.BorderDashStyle = System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid;

            chartArea1.Position.Auto = false;// true;
            chartArea1.Position.Height = 100F;
            chartArea1.Position.Width = 100F;
            chartArea1.Position.X = 0;
            chartArea1.Position.Y = 0;
            chartArea1.ShadowColor = System.Drawing.Color.Transparent;


            #endregion

            chart1.ChartAreas.Add(chartArea1);
            #endregion

            #region legend
            #region legend1
            legend1.Name = "legend1";
            legend1.Alignment = System.Drawing.StringAlignment.Near;
            legend1.IsTextAutoFit = false;
            legend1.BackColor = System.Drawing.Color.Transparent;
            legend1.Docking = Docking.Right;
            legend1.IsDockedInsideChartArea = true;
            legend1.DockedToChartArea = chartArea1.Name;
            legend1.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            legend1.LegendStyle = LegendStyle.Column;

            legend1.Position.Auto = true;

            #endregion

            chart1.Legends.Add(legend1);
            #endregion

            #region series
            #region series1
            series1.Name = "series1";
            series1.BorderColor = series_color;
            series1.BorderWidth = 2;
            series1.ChartArea = chartArea1.Name;
            series1.ChartType = SeriesChartType.Line;
            series1.Color = series_color;


            series1.XValueType = ChartValueType.Int32;
            series1.YValueType = ChartValueType.Double;

            series1.ShadowColor = System.Drawing.Color.Black;
            series1.ShadowOffset = 2;

            series1.IsVisibleInLegend = true;
            series1.Legend = legend1.Name;
            series1.LegendText = "扫描";
            #endregion

            #region series2
            series2.Name = "series2";
            series2.LegendText = "边界点";
            series2.ChartArea = chartArea1.Name;
            series2.ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Point;
            series2.Color = System.Drawing.Color.Green;
            series2.BorderColor = System.Drawing.Color.DarkGreen;
            series2.BorderWidth = 3;

            series2.MarkerSize = 6;
            series2.MarkerStyle = System.Windows.Forms.DataVisualization.Charting.MarkerStyle.Circle;
            series2.MarkerBorderColor = System.Drawing.Color.DarkGreen;
            series2.MarkerColor = System.Drawing.Color.Green;

            series2.ShadowColor = System.Drawing.Color.Black;
            series2.ShadowOffset = 2;
            #endregion

            chart1.Series.Add(series1);
            chart1.Series.Add(series2);
            #endregion

            chart1.Name = "chart1";
            chart1.Palette = System.Windows.Forms.DataVisualization.Charting.ChartColorPalette.BrightPastel;
            chart1.Location = new System.Drawing.Point(0, 0);

            //??????????????????????????????????????
            //((System.ComponentModel.ISupportInitialize)(this.chart1)).EndInit();

        }
        /// <summary>
        /// 分区数统计
        /// </summary>
        /// <param name="chart1"></param>
        void InitializeChart_bolts(Chart chart1, System.Drawing.Color series_color)
        {
            ChartArea chartArea1 = new ChartArea();

            Legend legend1 = new Legend();

            Series series1 = new Series();
            // 
            // chart1
            // 
            //this.chart1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(211)), ((System.Byte)(223)), ((System.Byte)(240)));
            //this.chart1.BackSecondaryColor = System.Drawing.Color.White;
            //this.chart1.BackGradientStyle = System.Windows.Forms.DataVisualization.Charting.GradientStyle.TopBottom;
            //this.chart1.BorderlineColor = System.Drawing.Color.FromArgb(((System.Byte)(26)), ((System.Byte)(59)), ((System.Byte)(105)));
            //this.chart1.BorderlineDashStyle = System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid;
            //this.chart1.BorderlineWidth = 2;
            //this.chart1.BorderSkin.SkinStyle = System.Windows.Forms.DataVisualization.Charting.BorderSkinStyle.Emboss;


            #region chartArea
            #region chartArea1
            chartArea1.Name = "chartArea1";

            chartArea1.AxisX.IsLabelAutoFit = false;
            chartArea1.AxisX.LabelStyle.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            chartArea1.AxisX.LabelStyle.IsEndLabelVisible = false;
            chartArea1.AxisX.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisX.MajorGrid.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisX.IntervalAutoMode = IntervalAutoMode.FixedCount;
            chartArea1.AxisX.LabelAutoFitStyle = LabelAutoFitStyles.DecreaseFont;
            chartArea1.AxisX.Interval = 5;

            chartArea1.AxisY.IsLabelAutoFit = true;
            chartArea1.AxisY.LabelStyle.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            chartArea1.AxisY.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisY.MajorGrid.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisY.IsStartedFromZero = true;
            chartArea1.AxisY.IntervalAutoMode = IntervalAutoMode.FixedCount;
            chartArea1.AxisY.LabelAutoFitStyle = LabelAutoFitStyles.DecreaseFont;
            chartArea1.AxisY.Title = "次数";

            //chartArea1.AxisY.Maximum = 100;
            //chartArea1.AxisY.Minimum = 0;
            //chartArea1.AxisY.Interval = 10;

            chartArea1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(165)), ((System.Byte)(191)), ((System.Byte)(228)));
            chartArea1.BackSecondaryColor = System.Drawing.Color.White;
            chartArea1.BackGradientStyle = System.Windows.Forms.DataVisualization.Charting.GradientStyle.TopBottom;
            chartArea1.BorderColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.BorderDashStyle = System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid;

            chartArea1.Position.Auto = false;// true;
            chartArea1.Position.Height = 100F;
            chartArea1.Position.Width = 100F;
            chartArea1.Position.X = 0;
            chartArea1.Position.Y = 0;
            chartArea1.ShadowColor = System.Drawing.Color.Transparent;


            #endregion

            chart1.ChartAreas.Add(chartArea1);
            #endregion

            #region legend
            #region legend1
            legend1.Name = "legend1";
            legend1.Alignment = System.Drawing.StringAlignment.Near;
            legend1.IsTextAutoFit = false;
            legend1.BackColor = System.Drawing.Color.Transparent;
            legend1.Docking = Docking.Right;
            legend1.IsDockedInsideChartArea = true;
            legend1.DockedToChartArea = chartArea1.Name;
            legend1.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            legend1.LegendStyle = LegendStyle.Column;

            legend1.Position.Auto = true;

            #endregion

            chart1.Legends.Add(legend1);
            #endregion

            #region series
            #region series1
            series1.Name = "series1";
            series1.BorderColor = series_color;
            series1.BorderWidth = 2;
            series1.ChartArea = chartArea1.Name;
            series1.ChartType = SeriesChartType.Column;
            series1.Color = series_color;

            series1.XValueType = ChartValueType.Int32;
            series1.YValueType = ChartValueType.Int32;

            series1.ShadowColor = System.Drawing.Color.Black;
            series1.ShadowOffset = 2;

            series1.IsVisibleInLegend = true;
            series1.Legend = legend1.Name;
            series1.LegendText = "分区统计";
            #endregion




            chart1.Series.Add(series1);

            #endregion

            chart1.Name = "chart1";
            chart1.Palette = System.Windows.Forms.DataVisualization.Charting.ChartColorPalette.BrightPastel;
            chart1.Location = new System.Drawing.Point(0, 0);

            //??????????????????????????????????????
            //((System.ComponentModel.ISupportInitialize)(this.chart1)).EndInit();

        }


        /// <summary>
        /// 平均图
        /// </summary>
        /// <param name="chart1"></param>
        void InitializeChart_avg(Chart chart1, System.Drawing.Color series_color)
        {
            ChartArea chartArea1 = new ChartArea();

            Legend legend1 = new Legend();

            Series series1 = new Series();
            // 
            // chart1
            // 
            //this.chart1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(211)), ((System.Byte)(223)), ((System.Byte)(240)));
            //this.chart1.BackSecondaryColor = System.Drawing.Color.White;
            //this.chart1.BackGradientStyle = System.Windows.Forms.DataVisualization.Charting.GradientStyle.TopBottom;
            //this.chart1.BorderlineColor = System.Drawing.Color.FromArgb(((System.Byte)(26)), ((System.Byte)(59)), ((System.Byte)(105)));
            //this.chart1.BorderlineDashStyle = System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid;
            //this.chart1.BorderlineWidth = 2;
            //this.chart1.BorderSkin.SkinStyle = System.Windows.Forms.DataVisualization.Charting.BorderSkinStyle.Emboss;


            #region chartArea
            #region chartArea1
            chartArea1.Name = "chartArea1";

            chartArea1.AxisX.IsLabelAutoFit = false;
            chartArea1.AxisX.LabelStyle.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            chartArea1.AxisX.LabelStyle.IsEndLabelVisible = false;
            chartArea1.AxisX.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisX.MajorGrid.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisX.Interval = 5;

            chartArea1.AxisY.IsLabelAutoFit = true;
            chartArea1.AxisY.LabelStyle.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            chartArea1.AxisY.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisY.MajorGrid.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.AxisY.IsStartedFromZero = true;
            chartArea1.AxisY.IntervalAutoMode = IntervalAutoMode.FixedCount;
            chartArea1.AxisY.LabelAutoFitStyle = LabelAutoFitStyles.DecreaseFont;
            chartArea1.AxisY.Title = "厚度";

            //chartArea1.AxisY.Maximum = 100;
            //chartArea1.AxisY.Minimum = 0;
            //chartArea1.AxisY.Interval = 10;

            chartArea1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(165)), ((System.Byte)(191)), ((System.Byte)(228)));
            chartArea1.BackSecondaryColor = System.Drawing.Color.White;
            chartArea1.BackGradientStyle = System.Windows.Forms.DataVisualization.Charting.GradientStyle.TopBottom;
            chartArea1.BorderColor = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
            chartArea1.BorderDashStyle = System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid;

            chartArea1.Position.Auto = false;// true;
            chartArea1.Position.Height = 100F;
            chartArea1.Position.Width = 100F;
            chartArea1.Position.X = 0;
            chartArea1.Position.Y = 0;
            chartArea1.ShadowColor = System.Drawing.Color.Transparent;


            #endregion

            chart1.ChartAreas.Add(chartArea1);
            #endregion

            #region legend
            #region legend1
            legend1.Name = "legend1";
            legend1.Alignment = System.Drawing.StringAlignment.Near;
            legend1.IsTextAutoFit = false;
            legend1.BackColor = System.Drawing.Color.Transparent;
            legend1.Docking = Docking.Right;
            legend1.IsDockedInsideChartArea = true;
            legend1.DockedToChartArea = chartArea1.Name;
            legend1.Font = new System.Drawing.Font("Trebuchet MS", 8.25F, System.Drawing.FontStyle.Bold);
            legend1.LegendStyle = LegendStyle.Column;

            legend1.Position.Auto = true;

            #endregion

            chart1.Legends.Add(legend1);
            #endregion

            #region series
            #region series1
            series1.Name = "series1";
            series1.BorderColor = series_color;
            series1.BorderWidth = 2;
            series1.ChartArea = chartArea1.Name;
            series1.ChartType = SeriesChartType.Line;
            series1.Color = series_color;

            series1.XValueType = ChartValueType.Int32;
            series1.YValueType = ChartValueType.Int32;

            series1.ShadowColor = System.Drawing.Color.Black;
            series1.ShadowOffset = 2;

            series1.IsVisibleInLegend = true;
            series1.Legend = legend1.Name;
            series1.LegendText = "平均值";
            #endregion




            chart1.Series.Add(series1);

            #endregion

            chart1.Name = "chart1";
            chart1.Palette = System.Windows.Forms.DataVisualization.Charting.ChartColorPalette.BrightPastel;
            chart1.Location = new System.Drawing.Point(0, 0);

            //??????????????????????????????????????
            //((System.ComponentModel.ISupportInitialize)(this.chart1)).EndInit();

        }
        public void Init(IPEndPoint serverep)
        {

            mRenZiJia = new BlowingScanServiceClient(FLY.Thick.BlowingScan.OBJ_INTERFACE.OBJ_INTERFACE_ID.RENZIJIA_ID);
            mBDetect = new BlowingDetectServiceClient(FLY.Thick.BlowingScan.OBJ_INTERFACE.OBJ_INTERFACE_ID.BDETECT_ID);

            FObjBase.FObjSys.Current.Connect_to_Another_OBJSys(
                serverep, mRenZiJia.ID, mBDetect.ID);

            stackpanel_bmRangeNewest.DataContext = mRenZiJia;

            mBorderSearch = new BorderSearchServiceClient(FLY.Thick.BlowingScan.OBJ_INTERFACE.OBJ_INTERFACE_ID.BORDERSEARCH_ID);
            FObjBase.FObjSys.Current.Connect_to_Another_OBJSys(
                serverep, mBorderSearch.ID);


            mAnaylze = new BlowingScanAnaylze();
            mAnaylze.MarkNo1.PropertyChanged += MarkNo_PropertyChanged;
            mAnaylze.MarkNo2.PropertyChanged += MarkNo_PropertyChanged;
            DataContext = mAnaylze;

            stackpanel_markno1.DataContext = mAnaylze.MarkNo1;

            stackpanel_markno2.DataContext = mAnaylze.MarkNo2;

            orgchart.Add(mAnaylze.MarkNo1, chart10);
            orgchart.Add(mAnaylze.MarkNo2, chart20);
            
            solveSeries.Add(mAnaylze.MarkNo1, chart1.Series[0]);
            solveSeries.Add(mAnaylze.MarkNo2, chart1.Series[1]);

            avgchart.Add(mAnaylze.MarkNo1, chart11);
            avgchart.Add(mAnaylze.MarkNo2, chart21);

            powerchart.Add(mAnaylze.MarkNo1, chart12);
            powerchart.Add(mAnaylze.MarkNo2, chart22);

            Misc.BindingOperations.SetBinding(mRenZiJia, "SolveCnt", mAnaylze, "SolveCnt");
            Misc.BindingOperations.SetBinding(mRenZiJia, "OrgBoltNo", mAnaylze, "OrgBoltNo");
            Misc.BindingOperations.SetBinding(mRenZiJia, "NBolts", mAnaylze, "NBolts");

            Misc.BindingOperations.SetBinding(mBDetect, "RAngle", mAnaylze, "RAngle");
            Misc.BindingOperations.SetBinding(mBDetect, "FilmLength", mAnaylze, "FilmLength");

            Misc.BindingOperations.SetBinding(mBorderSearch, "SensorWidth", mAnaylze, "Sensor");
            Misc.BindingOperations.SetBinding(mBorderSearch, "N2", mAnaylze, "N2");

            mAnaylze.PropertyChanged += MAnaylze_PropertyChanged;

            Misc.BindingOperations.SetBinding(this, "IsBufListLoading", UpdateIsRunning);

            ptimer.Tick += Ptimer_Tick;

            grid_solveprogress.DataContext = ptimer;


            mAnaylze.mGagedata.PropertyChanged += MGagedata_PropertyChanged;
            button_focus1_Click(null, null);

            this.text_download.DataContext = mRenZiJia;
        }

        private void MGagedata_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "OrgThicks")
            {
                UpdateGageGraph();
            }
        }

        private void Ptimer_Tick(object sender, EventArgs e)
        {
            if (IsRunning)
                return;

            if (mAnaylze.IsStep2Ing)
                return;
            //第2步，修改 旋转角度，膜距离 执行 解方程
            Thread t = new Thread(mAnaylze.Step2);
            t.IsBackground = true;
            t.Start();
        }

        void UpdateIsRunning()
        {
            if (mAnaylze.IsStep2Ing || IsBufListLoading)
            {
                IsRunning = true;
            }
            else
            {
                IsRunning = false;
            }
        }
        private void MAnaylze_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if ((e.PropertyName == "SolveCnt") ||
                (e.PropertyName == "RAngle") ||
                (e.PropertyName == "FilmLength") ||
                (e.PropertyName == "Smooth"))
            {
                //有数据时，才能计算
                if (mAnaylze.CanStep2())
                    ptimer.Start();
            }
            else if (e.PropertyName == "IsStep2Ing")
            {
                UpdateIsRunning();
            }

        }

        private void MarkNo_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            MarkData markdata = sender as MarkData;
            if (e.PropertyName == "IsValid")
            {
                if (markdata.IsValid == false)
                {
                    Dispatcher.Invoke(new Action<MarkData>(UpdateSolveGraph), markdata);
                    Dispatcher.Invoke(new Action<MarkData>(UpdateOrgGraph), markdata);
                    Dispatcher.Invoke(new Action<MarkData>(UpdateAvgGraph), markdata);
                    Dispatcher.Invoke(new Action<MarkData>(UpdatePowerGraph), markdata);
                }
            }
            if (e.PropertyName == "Thicks")
            {
                Dispatcher.Invoke(new Action<MarkData>(UpdateSolveGraph), markdata);
            }
            else if (e.PropertyName == "OrgThicks")
            {
                Dispatcher.Invoke(new Action<MarkData>(UpdateOrgGraph), markdata);
            }
            else if (e.PropertyName == "AvgThicks")
            {
                Dispatcher.Invoke(new Action<MarkData>(UpdateAvgGraph), markdata);
            }
            else if (e.PropertyName == "Power")
            {
                Dispatcher.Invoke(new Action<MarkData>(UpdatePowerGraph), markdata);
            }

        }

        /// <summary>
        /// 更新解方程图表
        /// </summary>
        void UpdateSolveGraph(MarkData markdata)
        {
            Series series = solveSeries[markdata];
            series.Points.Clear();
            if (!markdata.IsValid)
                return;
            int[] datas = markdata.Thicks;
            for (int i = 0; i < datas.Count(); i++)
            {
                int d = datas.ElementAt(i);
                series.Points.AddXY(
                    1 + i, d / 100.0);
                DataPoint point = series.Points[i];

                //设定空数据
                if (!Misc.MyBase.ISVALIDATA(d))
                    point.IsEmpty = true;
                else
                    point.IsEmpty = false;
            }

            ChartArea chartarea = chart1.ChartAreas[0];
            chartarea.AxisX.Minimum = 0;
            chartarea.AxisX.Maximum = mAnaylze.NBolts + 1;

            double?[] max = new double?[2];
            double?[] min = new double?[2];
            for (int i = 0; i < 2; i++)
            {
                max[i] = chart1.Series[i].Points.Max(
                (p) =>
                {
                    if (p.IsEmpty == true)
                        return null;
                    else
                        return p.YValues[0];
                });

                min[i] = chart1.Series[i].Points.Min(
                (p) =>
                {
                    if (p.IsEmpty == true)
                        return null;
                    else
                        return p.YValues[0];
                });
            }
            double? _max = max.Max();
            double? _min = min.Min();

            if (_max != null)
            {
                if (_max != _min)
                {
                    chartarea.AxisY.Minimum = ((double)_min - ((double)_max - (double)_min) / 10);
                    chartarea.AxisY.Maximum = ((double)_max + ((double)_max - (double)_min) / 10);
                }
                else
                {
                    chartarea.AxisY.Minimum = (double)_min - 10;
                    chartarea.AxisY.Maximum = (double)_max + 10;
                }
            }
            else
            {
                for (int i = 0; i < 2; i++)
                {
                    chart1.Series[i].Points.Clear();
                }
            }
        }
        void UpdateOrgGraph(MarkData markdata)
        {
            Chart chart1 = orgchart[markdata];
            Series series = chart1.Series[0];
            series.Points.Clear();

            if (!markdata.IsValid)
            {
                return;
            }
            int[] datas = markdata.OrgThicks;
            int posofgrid = markdata.PosOfGrid;
            Range border = markdata.Border;


            for (int i = 0; i < datas.Count(); i++)
            {
                int d = datas.ElementAt(i);
                series.Points.AddXY(
                    posofgrid * i, d / 100.0);
                DataPoint point = series.Points[i];

                //设定空数据
                if (!Misc.MyBase.ISVALIDATA(d))
                    point.IsEmpty = true;
                else
                    point.IsEmpty = false;
            }
            int bg = border.Begin / posofgrid;
            

            int eg = border.End / posofgrid;

            series = chart1.Series[1];
            series.Points.Clear();
            if (bg > 0 && bg < datas.Count())
                series.Points.AddXY(border.Begin, datas[bg] / 100.0);
            if (eg > 0 && eg < datas.Count())
                series.Points.AddXY(border.End, datas[eg] / 100.0);

            //更新X轴
            chart1.ChartAreas[0].AxisX.Minimum = 0;
            chart1.ChartAreas[0].AxisX.Maximum = datas.Count() * posofgrid;


            //更新Y轴
            int min = Misc.MyMath.Min(datas);
            int max = Misc.MyMath.Max(datas);
            if (min != max)
            {
                chart1.ChartAreas[0].AxisY.Minimum = (min - (max - min) / 10) / 100.0;
                chart1.ChartAreas[0].AxisY.Maximum = (max + (max - min) / 10) / 100.0;
            }
            else
            {
                if (min == Misc.MyBase.NULL_VALUE)
                {
                    chart1.ChartAreas[0].AxisY.Minimum = 0;
                    chart1.ChartAreas[0].AxisY.Maximum = 100;
                }
                else
                {
                    chart1.ChartAreas[0].AxisY.Minimum = min / 100.0 - 10;
                    chart1.ChartAreas[0].AxisY.Maximum = min / 100.0 + 10;
                }
            }
        }


        void UpdateGageGraph()
        {
            Chart chart1 = chart3;
            Series series = chart1.Series[0];
            series.Points.Clear();

            int[] datas = mAnaylze.mGagedata.OrgThicks;
            int posofgrid = mAnaylze.mGagedata.PosOfGrid;
            Range border = mAnaylze.mGagedata.Border;


            for (int i = 0; i < datas.Count(); i++)
            {
                int d = datas.ElementAt(i);
                series.Points.AddXY(
                    posofgrid * i, d / 100.0);
                DataPoint point = series.Points[i];

                //设定空数据
                if (!Misc.MyBase.ISVALIDATA(d))
                    point.IsEmpty = true;
                else
                    point.IsEmpty = false;
            }


            //更新X轴
            chart1.ChartAreas[0].AxisX.Minimum = 0;
            chart1.ChartAreas[0].AxisX.Maximum = datas.Count() * posofgrid;


            //更新Y轴
            int min = Misc.MyMath.Min(datas);
            int max = Misc.MyMath.Max(datas);
            if (min != max)
            {
                //chart1.ChartAreas[0].AxisY.Minimum = (min - (max - min) / 10) / 100.0;
                //chart1.ChartAreas[0].AxisY.Maximum = (max + (max - min) / 10) / 100.0;
            }
            else
            {
                if (min == Misc.MyBase.NULL_VALUE)
                {
                    chart1.ChartAreas[0].AxisY.Minimum = 0;
                    chart1.ChartAreas[0].AxisY.Maximum = 100;
                }
                else
                {
                    chart1.ChartAreas[0].AxisY.Minimum = min / 100.0 - 10;
                    chart1.ChartAreas[0].AxisY.Maximum = min / 100.0 + 10;
                }
            }
        }
        void UpdatePowerGraph(MarkData markdata)
        {
            Chart chart1 = powerchart[markdata];
            Series series = chart1.Series[0];
            series.Points.Clear();

            if (!markdata.IsValid)
            {
                return;
            }
            int[] datas = markdata.Power;

            for (int i = 0; i < datas.Count(); i++)
            {
                int d = datas.ElementAt(i);
                series.Points.AddXY(i+1, d);
                DataPoint point = series.Points[i];

            }

            //更新X轴
            chart1.ChartAreas[0].AxisX.Minimum = 0;
            chart1.ChartAreas[0].AxisX.Maximum = datas.Count();


            //更新Y轴
            int max = datas.Max();
            if (max!=0)
            {
                chart1.ChartAreas[0].AxisY.Minimum = 0;
                chart1.ChartAreas[0].AxisY.Maximum = max * 1.1; 
            }
            else
            {
                chart1.ChartAreas[0].AxisY.Minimum = 0;
                chart1.ChartAreas[0].AxisY.Maximum = 100;
            }
        }

        void UpdateAvgGraph(MarkData markdata)
        {
            Chart chart1 = avgchart[markdata];
            Series series = chart1.Series[0];
            series.Points.Clear();

            if (!markdata.IsValid)
            {
                return;
            }
            int[] datas = markdata.AvgThicks;

            for (int i = 0; i < datas.Count(); i++)
            {
                int d = datas.ElementAt(i);
                series.Points.AddXY(i + 1, d/100.0);
                DataPoint point = series.Points[i];

                //设定空数据
                if (!Misc.MyBase.ISVALIDATA(d))
                    point.IsEmpty = true;
                else
                    point.IsEmpty = false;
            }

            //更新X轴
            chart1.ChartAreas[0].AxisX.Minimum = 0;
            chart1.ChartAreas[0].AxisX.Maximum = datas.Count();


            //更新Y轴
            int min = Misc.MyMath.Min(datas);
            int max = Misc.MyMath.Max(datas);
            if (min != max)
            {
                chart1.ChartAreas[0].AxisY.Minimum = (min - (max - min) / 10) / 100.0;
                chart1.ChartAreas[0].AxisY.Maximum = (max + (max - min) / 10) / 100.0;
            }
            else
            {
                if (min == Misc.MyBase.NULL_VALUE)
                {
                    chart1.ChartAreas[0].AxisY.Minimum = 0;
                    chart1.ChartAreas[0].AxisY.Maximum = 100;
                }
                else
                {
                    chart1.ChartAreas[0].AxisY.Minimum = min / 100.0 - 10;
                    chart1.ChartAreas[0].AxisY.Maximum = min / 100.0 + 10;
                }
            }
        }
        void DataBindAll(Series series, IEnumerable<int> datas, double multi)
        {
            series.Points.Clear();

            for (int i = 0; i < datas.Count(); i++)
            {
                int d = datas.ElementAt(i);
                series.Points.AddXY(
                    1 + i, d / multi);
                DataPoint point = series.Points[i];

                //设定空数据
                if (!Misc.MyBase.ISVALIDATA(d))
                    point.IsEmpty = true;
                else
                    point.IsEmpty = false;
            }
        }
        private void Page_Loaded(object sender, RoutedEventArgs e)
        {

        }
        private void Page_Unloaded(object sender, RoutedEventArgs e)
        {
            mRenZiJia.Dispose();
        }


        private void button_download_Click(object sender, RoutedEventArgs e)
        {
            if (IsBufListLoading)
                return;

            ptimer.Stop();

            IsBufListLoading = true;
            mRenZiJia.GetBufList(
                (AsyncState, retData) =>
                {
                    GetBufListReponse reponse = retData as GetBufListReponse;

                    IsBufListLoading = false;
                    //第1步
                    mAnaylze.Step1(reponse.firstbm, reponse.lastbm, reponse.datas);

                    //第2步，修改 旋转角度，膜距离 执行 解方程
                    Thread t = new Thread(mAnaylze.Step2);
                    t.IsBackground = true;
                    t.Start();

                    ////第2步，修改 旋转角度，膜距离 执行
                    //mAnaylze.Step2();

                    //UpdateSolveGraph(mAnaylze.MarkNo1);
                    //UpdateOrgGraph(mAnaylze.MarkNo1);
                    //UpdateAvgGraph(mAnaylze.MarkNo1);
                    //UpdatePowerGraph(mAnaylze.MarkNo1);

                    //UpdateSolveGraph(mAnaylze.MarkNo2);
                    //UpdateOrgGraph(mAnaylze.MarkNo2);
                    //UpdateAvgGraph(mAnaylze.MarkNo2);
                    //UpdatePowerGraph(mAnaylze.MarkNo2);
                }, null);
        }

        private void button_save_Click(object sender, RoutedEventArgs e)
        {
            if (IsRunning)
                return;

            BufListSaveManager m = new BufListSaveManager();
            m.Init(mAnaylze);
            m.PreSave();
            Window_SaveDatas w = new Window_SaveDatas();
            w.Init(m);
            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            w.ShowDialog();
        }

        private void button_load_Click(object sender, RoutedEventArgs e)
        {
            if (IsRunning)
                return;

            System.Windows.Forms.OpenFileDialog open = new System.Windows.Forms.OpenFileDialog();
            open.Filter = "csv文件|*.csv";
            open.Title = "读取数据";
            open.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
            if (open.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                IsBufListLoading = true;
                if (mAnaylze.Load(open.FileName))
                {
                    FLY.ControlLibrary.Window_Tip.Show("缓存区加载", "加载成功!", TimeSpan.FromSeconds(2));
                    
                    //第1步
                    mAnaylze.Step1(0, mAnaylze.mBufList.Count() - 1, mAnaylze.mBufList);
                    //第2步，修改 旋转角度，膜距离 执行 解方程
                    Thread t = new Thread(mAnaylze.Step2);
                    t.IsBackground = true;
                    t.Start();
                }
                else
                {
                    FLY.ControlLibrary.Window_WarningTip.Show("缓存区加载", "加载失败，格式错!", TimeSpan.FromSeconds(2));
                }
                IsBufListLoading = false;
            }
        }






        private void button_pre1_Click(object sender, RoutedEventArgs e)
        {
            int n = mAnaylze.MarkNo1.Number;
            n--;
            if (n < mAnaylze.FirstBM)
                n = mAnaylze.FirstBM;
            mAnaylze.MarkNo1.Number = n;
            button_focus1_Click(null, null);
        }

        private void button_next1_Click(object sender, RoutedEventArgs e)
        {
            int n = mAnaylze.MarkNo1.Number;
            n++;
            if (n > mAnaylze.LastBM)
                n = mAnaylze.LastBM;
            mAnaylze.MarkNo1.Number = n;
            button_focus1_Click(null, null);
        }

        private void button_pre2_Click(object sender, RoutedEventArgs e)
        {
            int n = mAnaylze.MarkNo2.Number;
            n--;
            if (n < mAnaylze.FirstBM)
                n = mAnaylze.FirstBM;
            mAnaylze.MarkNo2.Number = n;
            button_focus2_Click(null, null);
        }

        private void button_next2_Click(object sender, RoutedEventArgs e)
        {
            int n = mAnaylze.MarkNo2.Number;
            n++;
            if (n > mAnaylze.LastBM)
                n = mAnaylze.LastBM;
            mAnaylze.MarkNo2.Number = n;
            button_focus2_Click(null, null);
        }
        
        private void button_solve_Click(object sender, RoutedEventArgs e)
        {
            ptimer.Stop();
            Ptimer_Tick(null, null);
        }


        #region INotifyPropertyChanged 接口
        protected void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
        #endregion

        private void button_select_Click(object sender, RoutedEventArgs e)
        {
            Button b = sender as Button;
            var cell = b.Tag as ScanInfoCell;

            int idx = mAnaylze.ScanInfoList.IndexOf(cell);
            int markno = mAnaylze.GetMarkNoFromRList(idx);
            if (mAnaylze.MarkNo1.IsFocus)
                mAnaylze.MarkNo1.Number = markno;
            else
                mAnaylze.MarkNo2.Number = markno;

        }

        private void button_focus1_Click(object sender, RoutedEventArgs e)
        {
            mAnaylze.MarkNo1.IsFocus = true;
            mAnaylze.MarkNo2.IsFocus = false;
        }

        private void button_focus2_Click(object sender, RoutedEventArgs e)
        {
            mAnaylze.MarkNo2.IsFocus = true;
            mAnaylze.MarkNo1.IsFocus = false;
        }

        private void button_calRa_Click(object sender, RoutedEventArgs e)
        {
            if (IsRunning)
                return;

            if (mAnaylze.IsStep2Ing)
                return;
            //第2步，修改 旋转角度，膜距离 执行 解方程
            Thread t = new Thread(mAnaylze.StepAutoSearchRAngle);
            t.IsBackground = true;
            t.Start();
        }

        private void button_calFl_Click(object sender, RoutedEventArgs e)
        {
            if (IsRunning)
                return;

            if (mAnaylze.IsStep2Ing)
                return;
            //第2步，修改 旋转角度，膜距离 执行 解方程
            Thread t = new Thread(mAnaylze.StepAutoSearchFilmLength);
            t.IsBackground = true;
            t.Start();
        }

        private void button_calAuto_Click(object sender, RoutedEventArgs e)
        {
            if (IsRunning)
                return;

            if (mAnaylze.IsStep2Ing)
                return;
            //第2步，修改 旋转角度，膜距离 执行 解方程
            Thread t = new Thread(mAnaylze.StepAutoSearchParams);
            t.IsBackground = true;
            t.Start();
        }
    }


    public class BufListSaveManager : SaveManager
    {
        BlowingScanAnaylze mAnaylze;
        public void Init(BlowingScanAnaylze anaylze)
        {
            mAnaylze = anaylze;
        }

        protected override void Output()
        {
            string path = SavePath;
            Return(mAnaylze.Save(path));
        }

        protected override bool Backup()
        {
            return true;
        }
    }

    public class ProgressTimer : INotifyPropertyChanged
    {

        /// <summary>
        /// 满9
        /// </summary>
        public int Progress { get; set; }
        
        /// <summary>
        /// Progress 最大值
        /// </summary>
        public int Max { get; set; } = 360;


        //
        // 摘要:
        //     获取或设置计时器刻度之间的时间段。
        //
        // 返回结果:
        //     刻度之间的时间段。默认值是 00:00:00。
        //
        // 异常:
        //   T:System.ArgumentOutOfRangeException:
        //     interval 小于 0 或大于 System.Int32.MaxValue 毫秒。
        [PropertyChanged.DoNotCheckEquality]
        public TimeSpan Interval { get; set; } = TimeSpan.FromSeconds(2);


        private Stopwatch stopwatch = new Stopwatch();
        DispatcherTimer t = new DispatcherTimer();
        DispatcherTimer t_reset = new DispatcherTimer();

        public event EventHandler Tick;

        public ProgressTimer()
        {
            t.Tick += T_Tick;
            t.Interval = TimeSpan.FromSeconds(0.1);

            t_reset.Tick += T_reset_Tick;
            t.Interval = TimeSpan.FromSeconds(0.1);
        }

        private void T_reset_Tick(object sender, EventArgs e)
        {
            Reset();
            t_reset.Stop();
        }

        public void Start()
        {
            Progress = 0;
            stopwatch.Restart();
            t.Start();
        }
        public void Stop()
        {
            t.Stop();
            t_reset.Start();
        }

        private void T_Tick(object sender, EventArgs e)
        {
            TimeSpan ts = stopwatch.Elapsed;

            double p = (double)(Max) * ts.TotalMilliseconds / Interval.TotalMilliseconds;
            if (p >= Max)
            {
                Progress = Max;
                stopwatch.Stop();
                t.Stop();
                Tick?.Invoke(this, e);
            }
            else
            {
                Progress = (int)p;
            }
        }

        public bool IsOK => (Progress == Max);
        public bool IsRunning => (Progress > 0);
        public void Reset()
        {
            Progress = 0;
        }

        #region INotifyPropertyChanged 成员

        public event PropertyChangedEventHandler PropertyChanged;
        protected void NotifyPropertyChanged(string propertyname)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyname));
            }
        }
        #endregion
    }

}
