﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using FLY.Thick.Base.Common;

using ThickTcpUiInWindow;
using ThickTcpUiInWindow.Converter;

namespace FLY.Thick.BlowingScan.UI.Client
{
    /// <summary>
    /// Page_Custom.xaml 的交互逻辑
    /// </summary>
    public partial class PgCustom : Page
    {
        SysParam msysparam;
        TDGage gage;
        public PgCustom()
        {
            InitializeComponent();
        }
        public void Init(TDGage gage)
        {
            this.gage = gage;
            msysparam = gage.mSysParam as SysParam;
        }
        private void Page_Loaded(object sender, RoutedEventArgs e)
        {
            this.DataContext = msysparam;
            textblock_lcus.DataContext = gage.mLCUS;
        }



        private void button_play_Click(object sender, RoutedEventArgs e)
        {
            //报警！！！！！！！！
            FLY.ControlLibrary.Window_WarningTip.Show(
                "测试",
                msysparam.WarningTipPath + " duration=5s",
                TimeSpan.FromSeconds(5),
                msysparam.WarningTipPath);
        }

        private void button_open_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Forms.FileDialog open = new System.Windows.Forms.OpenFileDialog();
            open.Filter = "mp3文件|*.mp3|wav文件|*.wav|所有文件|*.*";
            open.Title = "打开音乐文件";
            if (System.IO.Path.IsPathRooted(msysparam.WarningTipPath))
                open.InitialDirectory = System.IO.Path.GetDirectoryName(msysparam.WarningTipPath);
            else
                open.InitialDirectory = System.Environment.CurrentDirectory;

            if (open.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (open.FileName.StartsWith(System.Environment.CurrentDirectory))
                {
                    msysparam.WarningTipPath = open.FileName.Substring(System.Environment.CurrentDirectory.Length + 1);
                }
                else
                {
                    msysparam.WarningTipPath = open.FileName;
                }
            }
        }



        private void button_bulkdata_Click(object sender, RoutedEventArgs e)
        {
            gage.mBulkDataClient.Clear();
        }


        private void button_apply_Click(object sender, RoutedEventArgs e)
        {

            msysparam.Save();
            gage.Init2();
            FLY.ControlLibrary.Window_Tip.Show("成功", "保存成功！！",
                TimeSpan.FromSeconds(2));
            return;
        }

        private void button_bellring_Click(object sender, RoutedEventArgs e)
        {
            gage.mLCUS.On();
        }

        private void button_belloff_Click(object sender, RoutedEventArgs e)
        {
            gage.mLCUS.Off();
        }
    }

}
