﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using FLY.ControlLibrary;
using System.Collections.ObjectModel;

using FLY.Thick.BulkDataModule;
using FLY.Thick.Base.Client;
using FLY.Thick.Base.Common;
using ThickTcpUiInWindow;
using FLY.Thick.BlowingScan.Client;
using FLY.Thick.Blowing.Client;
using System.Threading.Tasks;

namespace FLY.Thick.BlowingScan.UI.Client
{
    /// <summary>
    /// Page_Main.xaml 的交互逻辑
    /// </summary>
    public partial class PgMain : Page
    {
        private ThickTcpUiInWindow.UIModule.FLYLayout mLayout;
        private FLYLayoutManager mManager;
        TDGage gage;
        public PgMain()
        {
            InitializeComponent();
        }
        public async Task Init(TDGage gage) 
        {
            LoadingProgress lp = Application.Current.Properties["LoadingProgress"] as LoadingProgress;


            this.gage = gage;
            stackpanel_dynarea.DataContext = gage.mDynArea;
            grid_initparam.DataContext = gage.mInitParamService;
            lp.Progress += 10;
            await Task.Delay(10);

            //-----------------------------------------------------------------------
            //加载主界界面 配置
            mLayout = new ThickTcpUiInWindow.UIModule.FLYLayout();
            mLayout.Load();
            grid_layout.DataContext = mLayout;

            //-----------------------------------------------------------------------
            //模块管理器
            mManager = new FLYLayoutManager();
            Application.Current.Properties["LayoutManager"] = mManager;

            mManager.myUIModules.Add("scangraph",
                new FLY.UI.Module.UIModuleInfo()
                {
                    UIModule = new ThickTcpUiInWindow.UIModule.UIModule_ScanGraph(),
                    Param = new FLY.UI.Module.UIModuleParam()
                    {
                        IsGraphCompnonent = true
                    }
                });
            mManager.myUIModules.Add("trendgraph",
                new FLY.UI.Module.UIModuleInfo()
                {
                    UIModule = new ThickTcpUiInWindow.UIModule.UIModule_TrendGraph(),
                    Param = new FLY.UI.Module.UIModuleParam()
                    {
                        IsGraphCompnonent = true
                    }
                });
            mManager.myUIModules.Add("fixgraph",
                new FLY.UI.Module.UIModuleInfo()
                {
                    UIModule = new UIModule.UIModule_FixGraph(),
                    Param = new FLY.UI.Module.UIModuleParam()
                    {
                        IsGraphCompnonent = true
                    }
                });
            mManager.myUIModules.Add("scangraph2", new FLY.UI.Module.UIModuleInfo()
            {
                UIModule = new UIModule.UIModule_ScanGraph2(),
                Param = new FLY.UI.Module.UIModuleParam()
                {
                    IsGraphCompnonent = true
                }
            });
            mManager.myUIModules.Add("trendgraphcircular", new FLY.UI.Module.UIModuleInfo()
            {
                UIModule = new UIModule.UIModule_ScanGraphCircular(),
                Param = new FLY.UI.Module.UIModuleParam()
                {
                    IsGraphCompnonent = true
                }
            });
            mManager.myUIModules.Add("dyareaio", new FLY.UI.Module.UIModuleInfo()
            {
                UIModule = new UIModule.UIModule_DynAreaIO(),
                Param = new FLY.UI.Module.UIModuleParam()
                {
                    IsDynAreaComponent = true,
                    IsUnique = true
                }
            });
            mManager.myUIModules.Add("dyareablowing", new FLY.UI.Module.UIModuleInfo()
            {
                UIModule = new UIModule.UIModule_DynAreaBlowing(),
                Param = new FLY.UI.Module.UIModuleParam()
                {
                    IsDynAreaComponent = true,
                    IsUnique = true
                }
            });
            mManager.myUIModules.Add("dyareaprofile", new FLY.UI.Module.UIModuleInfo()
            {
                UIModule = new UIModule.UIModule_DynAreaProfile(),
                Param = new FLY.UI.Module.UIModuleParam()
                {
                    IsDynAreaComponent = true,
                    IsUnique = true
                }
            });
            mManager.myUIModules.Add("dyareathick", new FLY.UI.Module.UIModuleInfo()
            {
                UIModule = new UIModule.UIModule_DynAreaThick(),
                Param = new FLY.UI.Module.UIModuleParam()
                {
                    IsDynAreaComponent = true,
                    IsUnique = true
                }
            });
            mManager.myUIModules.Add("dyareasample", new FLY.UI.Module.UIModuleInfo()
            {
                UIModule = new UIModule.UIModule_DynAreaSample(),
                Param = new FLY.UI.Module.UIModuleParam()
                {
                    IsDynAreaComponent = true,
                    IsUnique = true
                }
            });
            mManager.myUIModules.Add("dyareafilmwidth", new FLY.UI.Module.UIModuleInfo()
            {
                UIModule = new UIModule.UIModule_DynAreaFilmWidth(),
                Param = new FLY.UI.Module.UIModuleParam()
                {
                    IsDynAreaComponent = true,
                    IsUnique = true
                }
            });

            //-----------------------------------------------------------------------
            //通过模块管理器， 配置主界面
            mManager.Init(
                tabControl1,
                stackpanel_dynarea,
                stackpanel_menu,
                mLayout);
            lp.Progress += 10;
            await Task.Delay(10);

            mManager.LoadModule();
            lp.Progress += 10;
            await Task.Delay(10);


            //-----------------------------------------------------------------------
            //根据状态切换页面
            Misc.BindingOperations.SetBinding(gage.mDynArea, "ControllerState", UpdateControllerState);
            lp.Progress = 100;
            await Task.Delay(10);
        }
        void UpdateControllerState()
        {
            var st = mLayout.ControllerStates.Find(_st => _st.ControllerState == gage.mDynArea.ControllerState.ToString());
            if (st != null)
            {
                if (st.No >= 0 && st.No < this.tabControl1.Items.Count)
                    this.tabControl1.SelectedIndex = st.No;
            }
        }

        private void button_sysparam_click(object sender, RoutedEventArgs e)
        {
            if (stackpanel_menu.Children.Count > 0)
            {
                mLayout.IsInMenuSelect = true;
            }
            else
            {
                button_menu_click(sender, e);
            }
        }
        private void button_profile_click(object sender, RoutedEventArgs e)
        {
            PgProfileBlowing p = new PgProfileBlowing();
            p.Init(gage.mSysParam.ServerIPEP);
            (Application.Current.Properties["NavigationService"] as NavigationService).Navigate(p);

        }
        private void button_backmenu_click(object sender, RoutedEventArgs e)
        {
            mLayout.IsInMenuSelect = false;
        }
        private void button_menu_click(object sender, RoutedEventArgs e)
        {
            PgMenu p = new PgMenu();
            p.Init(gage);
            NavigationService.Navigate(p);
        }

        private void button_option_click(object sender, RoutedEventArgs e)
        {
            ThickTcpUiInWindow.MainEdit.PgMainEdit p = new ThickTcpUiInWindow.MainEdit.PgMainEdit();
            p.Init(mManager);
            NavigationService.Navigate(p);
        }
    }




}
