﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThickTcpUiInWindow;

namespace FLY.Thick.BlowingScan.UI.Client
{
    /// <summary>
    /// Page_Menu.xaml 的交互逻辑
    /// </summary>
    public partial class PgMenu : Page
    {
        TDGage gage;
        public PgMenu()
        {
            InitializeComponent();
            
        }
        public void Init(TDGage gage) 
        {
            this.gage = gage;
            this.DataContext = this.gage.mSysParam;
        }

        private void button_custom_Click(object sender, RoutedEventArgs e)
        {
            PgCustom p = new PgCustom();
            p.Init(gage);
            NavigationService.Navigate(p);
        }

        private void button_grid_Click(object sender, RoutedEventArgs e)
        {
            PgGrid p = new PgGrid();
            p.Init(gage.mInitParamService, gage.mTDGageService, gage.mFlyAdServiceClient, gage.mDynArea, gage.mWarningReasonWindow);
            NavigationService.Navigate(p);
        }

        private void button_initparam_Click(object sender, RoutedEventArgs e)
        {
            Page_Initparam p = new Page_Initparam();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }

        private void button_getsample_Click(object sender, RoutedEventArgs e)
        {
            Page_GetSample p = new Page_GetSample();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }

        private void button_bordersearch_Click(object sender, RoutedEventArgs e)
        {
            Page_BorderSearch p = new Page_BorderSearch();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }

        private void button_curve_Click(object sender, RoutedEventArgs e)
        {
            Page_Curve p = new Page_Curve();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }

        private void button_scancorr_Click(object sender, RoutedEventArgs e)
        {
            Page_ScanCorr p = new Page_ScanCorr();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }

        private void button_warning_Click(object sender, RoutedEventArgs e)
        {
            PgErrorTable p = new PgErrorTable();
            p.Init(gage.mWarningService, gage.mWarningReasonWindow, gage.mFlyAdServiceClient, typeof(WdIOTip));
            NavigationService.Navigate(p);
        }




        private void button_gageinfo_Click(object sender, RoutedEventArgs e)
        {
            Page_GageInfo p = new Page_GageInfo();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }

        private void button_flyad_Click(object sender, RoutedEventArgs e)
        {
            Page_FlyAD p = new Page_FlyAD();
            p.Init(gage.mSysParam.ServerIPEP, gage.mDynArea, gage.mTDGageService);

            NavigationService.Navigate(p);
        }

        private void button_passwork_Click(object sender, RoutedEventArgs e)
        {
            if (Window_Password.Authorize(1))
            {
                Window_PasswordEdit w = new Window_PasswordEdit();
                w.Init(gage.mSysParam.ServerIPEP, FLY.Thick.BlowingScan.OBJ_INTERFACE.OBJ_INTERFACE_ID.PASSWORD_ID);
                if (w.ShowDialog()==true) 
                {
                    
                }
            }
        }

        private void button_version_Click(object sender, RoutedEventArgs e)
        {
            System.Diagnostics.Process.Start(@"版本说明.txt");
        }

        private void button_curve2_Click(object sender, RoutedEventArgs e)
        {
            Page_CurveModify p = new Page_CurveModify();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }

        private void button_instruction_Click(object sender, RoutedEventArgs e)
        {
            System.Diagnostics.Process.Start(@"测厚仪说明书.pdf");
        }

        private void button_blowing_Click(object sender, RoutedEventArgs e)
        {
            PgBlowing p = new PgBlowing();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }

        private void button_buflist_Click(object sender, RoutedEventArgs e)
        {
            PgBufList p = new PgBufList();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }

        private void button_scanwarning_Click(object sender, RoutedEventArgs e)
        {
            PgScanWarning p = new PgScanWarning();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }
    }
}
