﻿using FLY.Thick.Base.Client;
using FLY.UI.Module;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThickTcpUiInWindow;

namespace FLY.Thick.BlowingScan.UI.Client.UIModule
{
    /// <summary>
    /// DynAreaFilmWidth.xaml 的交互逻辑
    /// </summary>
    public partial class DynAreaFilmWidth : UserControl
    {
        TDGage gage;
        public DynAreaFilmWidth()
        {
            InitializeComponent();
        }

        public void Init(int id)
        {
            //获取设备
            gage = Application.Current.Properties["ThickGage"] as TDGage;
            this.DataContext = gage.mDynArea;
        }

        private void Border_Width_Click(object sender, RoutedEventArgs e)
        {
            Page_BorderSearch p = new Page_BorderSearch();
            p.Init(gage.mSysParam.ServerIPEP);
            (Application.Current.Properties["NavigationService"] as NavigationService).Navigate(p);
        }
    }

    public class UIModule_DynAreaFilmWidth : IUIModule
    {
        /// <summary>
        /// 控件标题
        /// 它的值取决于culture
        /// </summary>
        public string Title
        {
            get
            {
                return "边界查找";
            }
        }

        /// <summary>
        /// 控件
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetComponent(int id)
        {
            DynAreaFilmWidth graph = new DynAreaFilmWidth();
            graph.Init(id);
            return graph;
        }

        /// <summary>
        /// 控件缩略图，用于编辑界面时，大致看看
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetThumbnail(int id)
        {
            return new System.Windows.Controls.Grid();
        }


        /// <summary>
        /// 给出全部控件ID, 控件自行删除没有的参数
        /// </summary>
        /// <param name="IDs"></param>
        public void MatchParam(int[] IDs)
        {

        }
    }
}
