﻿using FLY.Thick.Base.IService;
using FLY.Thick.Base.OBJ_INTERFACE;
using FLY.Thick.Base.Common;
using FLY.UI.Module;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThickTcpUiInWindow;
using static FLY.Thick.Base.Client.GetSampleServiceClient;
using System.ComponentModel;

namespace FLY.Thick.BlowingScan.UI.Client.UIModule
{
    /// <summary>
    /// DynAreaSample.xaml 的交互逻辑
    /// </summary>
    public partial class DynAreaSample : UserControl
    {
        TDGage gage;
        public DynAreaSample()
        {
            InitializeComponent();
        }
        public void Init(int id)
        {
            //获取设备
            gage = Application.Current.Properties["ThickGage"] as TDGage;
            this.DataContext = gage.mGetSampleServiceClient;
        }
        
        private void Border_Sample_Click(object sender, RoutedEventArgs e)
        {
            Page_GetSample p = new Page_GetSample();
            p.Init(gage.mSysParam.ServerIPEP);
            (Application.Current.Properties["NavigationService"] as NavigationService).Navigate(p);
        }
    }

    public class UIModule_DynAreaSample : IUIModule
    {
        /// <summary>
        /// 控件标题
        /// 它的值取决于culture
        /// </summary>
        public string Title
        {
            get
            {
                return "样品状态";
            }
        }

        /// <summary>
        /// 控件
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetComponent(int id)
        {
            DynAreaSample graph = new DynAreaSample();
            graph.Init(id);
            return graph;
        }

        /// <summary>
        /// 控件缩略图，用于编辑界面时，大致看看
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetThumbnail(int id)
        {
            return new System.Windows.Controls.Grid();
        }


        /// <summary>
        /// 给出全部控件ID, 控件自行删除没有的参数
        /// </summary>
        /// <param name="IDs"></param>
        public void MatchParam(int[] IDs)
        {
            
        }
    }

    public class DynAreaSampleVmUt:INotifyPropertyChanged
    {
        public DynAreaSampleVmUt()
        {

            for (int i = 0; i < Samples.Count(); i++)
            {
                SampleCell sampleCell = new SampleCell();
                sampleCell.Index = i;
                Samples[i] = sampleCell;
            }
            Features[0] = new SampleFeature() { Name = "正向" };
            Features[1] = new SampleFeature() { Name = "反向" };


            Enable = true;
            Interval = 20;
            Samples[0].Enable = true;

            Features[0].Enable = true;

        }

        #region IGetSampleService 成员

        /// <summary>
        /// 参数：使能
        /// </summary>
        public bool Enable { get; set; }

        /// <summary>
        /// 参数：间隔
        /// </summary>
        public int Interval { get; set; }

        /// <summary>
        /// 采样计数
        /// </summary>
        public int Timer { get; set; }

        /// <summary>
        /// 参数：速度
        /// </summary>
        public UInt32 Velocity { get; set; }

        /// <summary>
        /// 参数：样品点范围
        /// </summary>
        public int Range { get; set; }


        /// <summary>
        /// 滤波窗口
        /// </summary>
        public int Window { get; set; }

        /// <summary>
        /// 样品
        /// </summary>
        public ISampleCell[] Samples { get; } = new ISampleCell[3];

        /// <summary>
        /// 查找公差
        /// </summary>
        public int Search { get; set; }

        /// <summary>
        /// 特征  相识度 0 正， 1 反
        /// </summary>
        public ISampleFeature[] Features { get; } = new ISampleFeature[2];


        /// <summary>
        /// 状态：从flyad7 得到的。 用于绘制图
        /// </summary>
        public int PosOfGrid { get; set; } = 10;

        public event PropertyChangedEventHandler PropertyChanged;


        #endregion


    }


    [ValueConversion(typeof(object), typeof(int))]
    public class Item2IndexConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {

            int result = 0;
            var iLi = parameter as System.Collections.IList;
            if (null != iLi)
            {
                result = iLi.IndexOf(value) + 1;
            }
            return result > 0 ? result : System.Windows.DependencyProperty.UnsetValue;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
