﻿using FLY.OBJComponents.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Thick.BlowingScan.Common
{
    public static class ERRNOs
    {
        static ERRNOs()
        {
            BASE_ERRNO_RINGTEST = new ERRNO() { Code = 1, Descrption = "报警测试" };
            BASE_ERRNO_AD_MIN = new ERRNO() { Code = 2, Descrption = "AD值太小" };
            BASE_ERRNO_AD_MAX = new ERRNO() { Code = 3, Descrption = "AD值太大" };
            BASE_ERRNO_EMERGENCY = new ERRNO() { Code = 4, Descrption = "急停" };
            BASE_ERRNO_LIMIT = new ERRNO() { Code = 5, Descrption = "限位" };
            BASE_ERRNO_FLYAD7DISCONNECTED = new ERRNO() { Code = 6, Descrption = "枫莱尔控制器连接断开" };
            BASE_ERRNO_LICENSE_TIP = new ERRNO() { Code = 7, Descrption = "授权将要过期" };
            BASE_ERRNO_LICENSE = new ERRNO() { Code = 8, Descrption = "授权限制" };
            BASE_ERRNO_FILE_ERR_RESTORE = new ERRNO() { Code = 9, Descrption = "数据文件异常，恢复不成功" };
            BASE_ERRNO_FILE_RESTORE = new ERRNO() { Code = 10, Descrption = "数据文件异常，恢复成功" };
            SCAN_ERRNO_OVERCTRL = new ERRNO() { Code = 11, Descrption = "扫描超控制报警" };
            SCAN_ERRNO_OVERTOL = new ERRNO() { Code = 12, Descrption = "扫描超规格报警" };
        }
        #region 基础报警类型
        /// <summary>
        /// 报警测试
        /// </summary>
        public static ERRNO BASE_ERRNO_RINGTEST;

        /// <summary>
        /// AD值太小
        /// </summary>
        public static ERRNO BASE_ERRNO_AD_MIN;

        /// <summary>
        /// AD值太大
        /// </summary>
        public static ERRNO BASE_ERRNO_AD_MAX;

        /// <summary>
        /// 急停
        /// </summary>
        public static ERRNO BASE_ERRNO_EMERGENCY;

        /// <summary>
        /// 限位
        /// </summary>
        public static ERRNO BASE_ERRNO_LIMIT;

        /// <summary>
        /// 枫莱尔控制器连接断开
        /// </summary>
        public static ERRNO BASE_ERRNO_FLYAD7DISCONNECTED;

        /// <summary>
        /// 授权限制,提醒
        /// </summary>
        public static ERRNO BASE_ERRNO_LICENSE_TIP;

        /// <summary>
        /// 授权限制
        /// </summary>
        public static ERRNO BASE_ERRNO_LICENSE;

        /// <summary>
        /// 数据文件加载出错
        /// </summary>
        public static ERRNO BASE_ERRNO_FILE_ERR_RESTORE;

        /// <summary>
        /// 数据文件加载出错
        /// </summary>
        public static ERRNO BASE_ERRNO_FILE_RESTORE;
        #endregion



        /// <summary>
        /// 扫描超控制报警
        /// </summary>
        public static ERRNO SCAN_ERRNO_OVERCTRL;
        /// <summary>
        /// 扫描超规格报警
        /// </summary>
        public static ERRNO SCAN_ERRNO_OVERTOL;

    }
}
