﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FLY.Thick.BulkDataModule;
using FLY.Thick.Base.Server.OBJProxy;
using FLY.Thick.Blowing.Server.OBJProxy;
using FLY.Thick.BlowingScan.OBJ_INTERFACE;

using ScanWarning_OBJProxy = FLY.Thick.Blowing.Server.OBJProxy.ScanWarning_OBJProxy;

namespace FLY.Thick.BlowingScan.Server.OBJProxy
{
    /// <summary>
    /// 
    /// </summary>
    public class OBJProxys
    {
        BulkDataService_OBJProxy mBulkDataOBJProxy;
        Initparam_OBJProxy mInitParamOBJProxy;
        BorderSearch_OBJProxy mBorderSearchOBJProxy;
        Curve_OBJProxy mCurveOBJProxy;
        DynArea_OBJProxy mDynAreaOBJProxy;
        GetSample_OBJProxy mGetSampleOBJProxy;
        ScanCorr_OBJProxy mScanCorrOBJProxy;
        FlyAD_OBJProxy mFlyADOBJProxy;
        GageInfo_OBJProxy mGageInfoOBJProxy;
        Fix_OBJProxy mFixOBJProxy;
        BlowingProfile_OBJProxy mProfileOBJProxy;
        FLY.OBJComponents.Server.OBJProxy.WarningSystem_OBJProxy mWarnSystemOBJProxy;

        Password_OBJProxy mPasswordOBJProxy;
        TDGage_OBJProxy mTDGageOBJProxy;
        BlowingScan_OBJProxy mBlowingOBJProxy;
        BlowingDetect_OBJProxy mBDetectOBJProxy;
        ScanWarning_OBJProxy mScanWarningOBJProxy;
        BulkDB_OBJProxy mBulkDBOBJProxy;
        /// <summary>
        /// 
        /// </summary>
        /// <param name="objsys_idx"></param>
        /// <param name="gage"></param>
        public OBJProxys(int objsys_idx, TDGage gage)
        {
            TDGage mGage = gage;
            mBulkDataOBJProxy = new BulkDataService_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.BULK_ID, mGage.mBulk);


            mProfileOBJProxy = new BlowingProfile_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.PROFILE_ID, mGage.mProfile);

            mBorderSearchOBJProxy = new BorderSearch_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.BORDERSEARCH_ID, mGage.mBorderSearch);
            
            mCurveOBJProxy = new Curve_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.CURVE_ID, mGage.mCurve);

            mDynAreaOBJProxy = new DynArea_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.DYNAREA_ID, mGage.mDynArea);

            mGetSampleOBJProxy = new GetSample_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.GET_SAMPLE_ID, mGage.mGetSample);

            mInitParamOBJProxy = new Initparam_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.INITPARAM_ID, mGage.mInitParam);

            mScanCorrOBJProxy = new ScanCorr_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.SCANCORR_ID, mGage.mGMScanCorr);

            mFlyADOBJProxy = new FlyAD_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.FLYAD_ID, mGage.mFlyAD, mGage.AD2Thick);

            mGageInfoOBJProxy = new GageInfo_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.GAGEINFO_ID , mGage.mGMGageInfo);

            mFixOBJProxy = new Fix_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.FIX_ID, mGage.mGMFix);

            mWarnSystemOBJProxy = new FLY.OBJComponents.Server.OBJProxy.WarningSystem_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.WARNING_OBJ_ID, mGage.mWarning);

            
            mPasswordOBJProxy = new Password_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.PASSWORD_ID, mGage.mPassword);

            mTDGageOBJProxy = new TDGage_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.TDGAGE_ID, mGage);

            mBlowingOBJProxy = new BlowingScan_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.RENZIJIA_ID, mGage.mGMRenZiJiaScan);

            mBDetectOBJProxy = new BlowingDetect_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.BDETECT_ID, mGage.mGMRenZiJiaScan.mPDetect);

            mScanWarningOBJProxy = new ScanWarning_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.SCANWARNING_ID, mGage.mScanWarning);

            mBulkDBOBJProxy = new BulkDB_OBJProxy(objsys_idx, OBJ_INTERFACE_ID.BULKDB_ID, mGage.mBulkDb);


            mTDGageOBJProxy.CurrObjSys.Start_Conn_Server(
                mGage.mSysParam.LocalEP,
                mBulkDataOBJProxy.ID);
        }
    }
}
