﻿using FLY.Thick.Blowing.Server.Model;
using SQLite;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Thick.BlowingScan.Server.Model
{
    /// <summary>
    /// 原始数据 数据库对象
    /// </summary>
    public class OrgDbModel : SQLiteDbContext
    {
        /// <summary>
        /// 转向信号表对象
        /// </summary>
        public DBTable<Db_Sign> TbSign { get; } = new DBTable<Db_Sign>();

        /// <summary>
        /// 辊信号表对象
        /// </summary>
        public DBTable<Db_Roll> TbRoll { get; } = new DBTable<Db_Roll>();

        /// <summary>
        /// 扫描数据表对象
        /// </summary>
        public DBTable<Db_OrgScanData> TbOrgScanData { get; } = new DBTable<Db_OrgScanData>();


        /// <summary>
        /// 
        /// </summary>
        /// <param name="dbpath"></param>
        public OrgDbModel(string dbpath) : base(dbpath)
        {

        }
        
        /// <summary>
        /// 
        /// </summary>
        public OrgDbModel() : this(@"D:\blowingdata\thickness_scan_org.sqlite3")
        {

        }
    }
}
