﻿using SQLite;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Thick.BlowingScan.Server.Model
{
    /// <summary>
    /// 原始厚度表
    /// </summary>
    [Table("OrgScanData")]
    public class Db_OrgScanData
    {
        /// <summary>
        /// key
        /// </summary>
        [Key]
        [PropertyIndex(0)]
        public Int64 ID { get; set; }

        /// <summary>
        /// 时间
        /// </summary>
        [PropertyIndex(1)]
        public DateTime Time { get; set; }

        /// <summary>
        /// 边界开始
        /// </summary>
        [PropertyIndex(2)]
        public int FilmBegin { get; set; }

        /// <summary>
        /// 边界结束
        /// </summary>
        [PropertyIndex(3)]
        public int FilmEnd { get; set; }

        /// <summary>
        /// pos / grid
        /// </summary>
        [PropertyIndex(4)]
        public int PosOfGrid { get; set; }

        /// <summary>
        /// 斜率补偿
        /// </summary>
        [PropertyIndex(5)]
        public double K { get; set; }

        /// <summary>
        /// 厚度数据 double[]  总数量为grid总数
        /// </summary>
        [PropertyIndex(6)]
        public string Thicks { get; set; }

        /// <summary>
        /// 测量时间 datetime[]  总数量为grid总数
        /// </summary>
        [PropertyIndex(7)]
        public string ThicksDt { get; set; }
    }


}
