﻿using FLY.Thick.Blowing.IService;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Thick.BlowingScan.Server.Model
{
    /// <summary>
    /// 原始厚度表
    /// </summary>
    public class Lc_OrgScanData
    {
        /// <summary>
        /// key
        /// </summary>
        public Int64 ID { get; set; }

        /// <summary>
        /// 时间
        /// </summary>
        public DateTime Time { get; set; }

        /// <summary>
        /// 边界开始
        /// </summary>
        public int FilmBegin { get; set; }

        /// <summary>
        /// 边界结束
        /// </summary>
        public int FilmEnd { get; set; }

        /// <summary>
        /// pos / grid
        /// </summary>
        public int PosOfGrid { get; set; }

        /// <summary>
        /// 斜率补偿
        /// </summary>
        public double K { get; set; }

        /// <summary>
        /// 厚度数据 double[]  总数量为grid总数
        /// </summary>
        public double[] Thicks { get; set; }

        /// <summary>
        /// 测量时间 datetime[]  总数量为grid总数
        /// </summary>
        public DateTime[] ThicksDt { get; set; }
    }




}
