﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;

namespace FLY.Weight.UI.Client.Converter
{
    public class RatioConverter : IValueConverter
    {

        #region IValueConverter 成员

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            UInt16 v = (UInt16)value;
            string ratio_s = (string)parameter;
            double ratio;
            if (!double.TryParse(ratio_s, out ratio))
                return (double)v;
            else
                return (double)v * ratio;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string s_v = (string)value;
            double v;
            if (!double.TryParse(s_v, out v))
                return null;


            string ratio_s = parameter as string;
            double ratio;
            if (!double.TryParse(ratio_s, out ratio))
                return (UInt16) v;
            else
                return (UInt16)(v / ratio);
        }

        #endregion
    }
}
