﻿using FLY.OBJComponents.Client;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FLY.Weight.UI.Client
{
    /// <summary>
    /// Page_Screw.xaml 的交互逻辑
    /// </summary>
    public partial class Page_Hopper : Page
    {
        FLY.Weight.Client.WeightSystemClient mWeighterCsService;


        List<SetPLCUpdatePlan> setPlan_items = new List<SetPLCUpdatePlan>();

        public Page_Hopper()
        {
            InitializeComponent();

            Init();
        }
        void Init()
        {
            mWeighterCsService = TDGage.Current.mWeighterCsService;
            root_grid.DataContext = mWeighterCsService;

            RebuildPlans();

            mWeighterCsService.ResetItemsEvent += MWeighterCsService_ResetItemsEvent;
        }

        private void MWeighterCsService_ResetItemsEvent()
        {
            RebuildPlans();
        }
        /// <summary>
        /// 由于数量改变，重新构造更新计划
        /// </summary>
        void RebuildPlans()
        {

            foreach (SetPLCUpdatePlan plan in setPlan_items)
                plan.Dispose();
            setPlan_items.Clear();


            for (int i = 0; i < mWeighterCsService.Items.Count(); i++)
            {
                setPlan_items.Add(new SetPLCUpdatePlan(
                    mWeighterCsService.PLCos,
                    mWeighterCsService.Items[i],
                    new string[] {
                        "UnloadingTime",
                        "ZeroStableTime",
                        "FlowSwitchEnable",
                        "SampleTimeSet",
                        "WeightStableTime",
                        "MixingTimeSet",

                        "MixSet",
                        "ScrewMotorRatedFreq",
                        "MaterialLowLimitSet",
                        "AlarmDeviationSet",
                        "WeightCorrectFactor",
                        "LackErrorSet"
                    }));
            }
        }

        private void button_back_Click(object sender, RoutedEventArgs e)
        {

            NavigationService.GoBack();
        }

        private void button_apply_Click(object sender, RoutedEventArgs e)
        {

        }

        private void Page_Unloaded(object sender, RoutedEventArgs e)
        {
            foreach (var setPlan in setPlan_items)
            {
                setPlan.Dispose();
            }
        }
    }
}
