﻿using FLY.Weight.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FLY.Weight.UI.Client
{
    /// <summary>
    /// Page_Menu.xaml 的交互逻辑
    /// </summary>
    public partial class Page_Menu : Page
    {
        public Page_Menu()
        {
            InitializeComponent();

            Init();
        }

        public void Init()
        {
            wrappanel_root.DataContext = TDGage.Current.mWeighterCsService;
        }

        private void button_ingredient_Click(object sender, RoutedEventArgs e)
        {
            Page_Ingredient p = new Page_Ingredient();

            NavigationService.Navigate(p);
        }

        private void button_screw_Click(object sender, RoutedEventArgs e)
        {
            Page_Screw p = new Page_Screw();

            NavigationService.Navigate(p);
        }

        private void button_hopper_Click(object sender, RoutedEventArgs e)
        {
            Page_Hopper p = new Page_Hopper();
            NavigationService.Navigate(p);
        }

        private void button_error_Click(object sender, RoutedEventArgs e)
        {
            Page_ErrorTable p = new Page_ErrorTable();
            NavigationService.Navigate(p);
        }

        private void button_thickness_Click(object sender, RoutedEventArgs e)
        {
            Page_Thickness p = new Page_Thickness();
            NavigationService.Navigate(p);
        }

        private void button_rollmixtable_Click(object sender, RoutedEventArgs e)
        {
            NavigationService ns = Application.Current.Properties["NavigationService"] as NavigationService;
            if (ns != null)
            {
                Page_RollMixTable p = new Page_RollMixTable();
                WeighterC weight = ((Button)sender).Tag as WeighterC;
                p.Init(weight);
                ns.Navigate(p);
            }
        }

        private void button_mixtable_Click(object sender, RoutedEventArgs e)
        {
            NavigationService ns = Application.Current.Properties["NavigationService"] as NavigationService;
            if (ns != null)
            {
                Page_MixTable p = new Page_MixTable();
                WeighterC weight = ((Button)sender).Tag as WeighterC;
                p.Init(weight);
                ns.Navigate(p);
            }
        }

        private void button_version_Click(object sender, RoutedEventArgs e)
        {

        }

        private void button_flow_Click(object sender, RoutedEventArgs e)
        {
            NavigationService ns = Application.Current.Properties["NavigationService"] as NavigationService;
            if (ns != null)
            {
                Page_FlowTable p = new Page_FlowTable();
                p.Init();
                ns.Navigate(p);
            }
        }
    }
}
