﻿using FLY.Weight.UI.Client.UIModule;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Text;

namespace FLY.Weight.UI.Client
{
    public class SysParam : Misc.ISaveToXml, INotifyPropertyChanged
    {
        static SysParam current;
        public static SysParam Current
        {
            get
            {
                if (current == null)
                {
                    current = new SysParam();
                }
                return current;
            }
        }

        #region 属性，成员变量的代理
        public IPEndPoint ServerEP { get; set; }

        /// <summary>
        /// 主界面显示厚度
        /// </summary>
        public bool HasThickness { get; set; } = true;

        /// <summary>
        /// 由于不支持int[] 所以要使用string，以后再转换
        /// </summary>
        public string BinCnts_json { get; set; } = JsonConvert.SerializeObject(new int[] {4,4,4});// "[4,4,4]";


        /// <summary>
        /// 数组
        /// </summary>
        public int[] BinCnts {
            get{
                return JsonConvert.DeserializeObject<int[]>(BinCnts_json);
            }
            set {
                string json = JsonConvert.SerializeObject(value);
                BinCnts_json = json;
            }
        }
        public FlowGraphParams GraphParams { get; } = new FlowGraphParams();


        public string Path = "weightparam.xml";
        #endregion

        static SysParam()
        {
            Misc.SaveToXmlHepler.Regist(typeof(FlowGraphParams));
        }
        public SysParam()
        {
            ServerEP = Misc.StringConverter.ToIPEndPoint("127.0.0.1:20005");
            if (!Load())
                Save();

            this.PropertyChanged += SysParam_PropertyChanged;
        }

        private void SysParam_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "BinCnts")
            {
                Save();
            }
        }

        public bool Load()
        {
            return Misc.SaveToXmlHepler.Load(Path, this);
        }
        public void Save()
        {
            Misc.SaveToXmlHepler.Save(Path, this);
        }

        public string[] GetSavePropertyNames()
        {
            return new string[]{
                "ServerEP",
                "BinCnts_json",
                "HasThickness",
                "GraphParams"
            };
        }
        protected void NotifyProperty(string propertyname)
        {
            if (PropertyChanged != null)
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyname));
        }
        public event PropertyChangedEventHandler PropertyChanged;
    }

}
