﻿using System;
using System.Collections.Generic;

using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Data;
using System.Windows.Media;

namespace FLY.Weight.UI.Client
{
    public class WeighterColorDB
    {
        const int BIN_COUNT = 5;
        const int WEIGHT_COUNT = 5;
        class WeighterColor
        {
            public Brush Self;
            public List<Brush> Items = new List<Brush>();
            public WeighterColor()
            {
            }
        }
        static Dictionary<string, WeighterColor> mWeighters;
        static WeighterColorDB()
        {
            ResourceDictionary r = new ResourceDictionary()
            {
                Source = new Uri("pack://application:,,,/FLY.Weight.UI.Client;component/Themes/Dictionary_CellColor.xaml")
            };

            mWeighters = new Dictionary<string, WeighterColor>();

            for (int i = 0; i < WEIGHT_COUNT; i++)
            {
                WeighterColor c = new WeighterColor();
                string color_name = "Color_g" + (i + 1).ToString() + "#0";
                c.Self = r[color_name] as Brush;
                for (int j = 0; j < BIN_COUNT; j++)
                {
                    color_name = "Color_g" + (i + 1).ToString() + "#" + (j + 1).ToString();
                    c.Items.Add(r[color_name] as Brush);
                }
                mWeighters.Add("" + (char)('A' + i), c);
            }

        }

        public static Brush GetSelf(string Number)
        {
            if (!mWeighters.ContainsKey(Number))
                return null;
            return mWeighters[Number].Items[0];
        }
        public static Brush GetItem(string Number, int index)
        {
            if (!mWeighters.ContainsKey(Number))
                return null;
            //if (index >= 5 || index < 0)
            //    return null;
            if (index >= BIN_COUNT || index < 0)
            {
                Random r = new Random();
                index = r.Next(BIN_COUNT - 1);
            }
            return mWeighters[Number].Items[index];
        }
    }
    public class Number2ColorValueConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            string number = value as string;
            return WeighterColorDB.GetSelf(number);
        }
        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
    public class Number2ColorItemValueConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            string number = value as string;
            int index = (int)parameter;
            return WeighterColorDB.GetItem(number, index);
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
