﻿using FLY.ControlLibrary;
using FLY.OBJComponents.Client;
using FLY.Weight.Client;
using FLY.Weight.Common;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FLY.Weight.UI.Client
{
    /// <summary>
    /// Window_RatioSet.xaml 的交互逻辑
    /// </summary>
    public partial class Window_Ingredient : WindowBigClose
    {
        WeightSystemClient mWeighterCsService;
        WeighterC weight;
        SetPLCUpdatePlan setPlan;

        public Window_Ingredient()
        {
            InitializeComponent();
        }
        public void Init(WeighterC weight)
        {
            mWeighterCsService = TDGage.Current.mWeighterCsService;
            this.weight = weight;
            this.grid_weighter.DataContext = weight;

            List<string> props = new List<string>();
            props.Add("MixSet");
            props.Add("MixBucketWeight");
            props.Add("CumulativeProduction");

            for (int j = 0; j < weight.BinCnt; j++)
            {
                int no = j + 1;
                //props.Add("MixPSet_" + no);
                //props.Add("MixPDisp_" + no);
                props.Add("MixCumPercent_" + no);

                //props.Add("MixSet_" + no);
                //props.Add("MixDisp_" + no);
                props.Add("MixCum_" + no);
            }
            setPlan = new SetPLCUpdatePlan(
                mWeighterCsService.PLCos,
                weight,
                props);
        }

        private void button_clear_Click(object sender, RoutedEventArgs e)
        {
            this.weight.ClearProduction = true;
        }


        private void button_mix_Click(object sender, RoutedEventArgs e)
        {
            NavigationService ns = Application.Current.Properties["NavigationService"] as NavigationService;
            if (ns != null)
            {
                this.Close();
                Page_MixTable p = new Page_MixTable();
                p.Init(weight);
                ns.Navigate(p);
            }
        }

        private void button_rollmix_Click(object sender, RoutedEventArgs e)
        {
            NavigationService ns = Application.Current.Properties["NavigationService"] as NavigationService;
            if (ns != null)
            {
                this.Close();
                Page_RollMixTable p = new Page_RollMixTable();
                p.Init(weight);
                ns.Navigate(p);
            }
        }

        private void WindowBigClose_Unloaded(object sender, RoutedEventArgs e)
        {
            setPlan.Dispose();
        }
    }

}
