﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FLY.Weight.UI.Client
{
    /// <summary>
    /// Window_Thickness.xaml 的交互逻辑
    /// </summary>
    public partial class Window_Thickness : FLY.ControlLibrary.WindowBigClose, INotifyPropertyChanged
    {
        private int setthickness = 80;
        public int SetThickness
        {
            get
            {
                return setthickness;
            }
            set
            {
                if (setthickness != value)
                {
                    setthickness = value;
                    NotifyPropertyChanged("SetThickness");
                }
            }
        }

        private int filmwidth = 500;
        public int FilmWidth
        {
            get
            {
                return filmwidth;
            }
            set
            {
                if (filmwidth != value)
                {
                    filmwidth = value;
                    NotifyPropertyChanged("FilmWidth");
                }
            }
        }

        private int rimwidth = 10;
        public int RimWidth
        {
            get
            {
                return rimwidth;
            }
            set
            {
                if (rimwidth != value)
                {
                    rimwidth = value;
                    NotifyPropertyChanged("RimWidth");
                }
            }
        }

        private bool isRimNoRecycle = true;
        public bool IsRimNoRecycle
        {
            get
            {
                return isRimNoRecycle;
            }
            set
            {
                if (isRimNoRecycle != value)
                {
                    isRimNoRecycle = value;
                    NotifyPropertyChanged("IsRimNoRecycle");
                }
            }
        }
        public Window_Thickness()
        {
            InitializeComponent();
            this.DataContext = this;
        }


        private void button_ok_Click(object sender, RoutedEventArgs e)
        {
            if (SetThickness < 10)
            {
                FLY.ControlLibrary.Window_WarningTip.Show("异常", "设置厚度 必须大于 10um");
                return;
            }

            if (FilmWidth < 300)
            {
                FLY.ControlLibrary.Window_WarningTip.Show("异常", "吹膜宽度 必须大于 300mm");
                return;
            }

            if ( RimWidth*2 > FilmWidth)
            {
                FLY.ControlLibrary.Window_WarningTip.Show("异常", "切边宽度*2 必须大于 吹膜宽度");
                return;
            }

            this.DialogResult = true;
            this.Close();
        }

        protected void NotifyPropertyChanged(string propertyname)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyname));
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
