﻿using FLY.OBJComponents.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FLY.Weight.Common
{
    public static class ERRNOs
    {
        public static byte TYPE = 10;
        static ERRNOs()
        {
            ERRNO_PLC_DISCONNECTED = new ERRNO() { Code = 255, Descrption = "称重 PLC连接断开" };
            WEIGHT_ERRNO_LACK1 = new ERRNO() { Code = 0, Descrption = "No.1料仓缺料报警" };
            WEIGHT_ERRNO_LACK2 = new ERRNO() { Code = 1, Descrption = "No.2料仓缺料报警" };
            WEIGHT_ERRNO_LACK3 = new ERRNO() { Code = 2, Descrption = "No.3料仓缺料报警" };
            WEIGHT_ERRNO_LACK4 = new ERRNO() { Code = 3, Descrption = "No.4料仓缺料报警" };
            WEIGHT_ERRNO_LACK5 = new ERRNO() { Code = 4, Descrption = "No.5料仓缺料报警" };
            WEIGHT_ERRNO_LACK6 = new ERRNO() { Code = 5, Descrption = "No.6料仓缺料报警" };

            WEIGHT_ERRNO_ADD1 = new ERRNO() { Code = 10, Descrption = "No.1料斗加料异常" };
            WEIGHT_ERRNO_ADD2 = new ERRNO() { Code = 11, Descrption = "No.2料斗加料异常" };
            WEIGHT_ERRNO_ADD3 = new ERRNO() { Code = 12, Descrption = "No.3料斗加料异常" };
            WEIGHT_ERRNO_ADD4 = new ERRNO() { Code = 13, Descrption = "No.4料斗加料异常" };
            WEIGHT_ERRNO_ADD5 = new ERRNO() { Code = 14, Descrption = "No.5料斗加料异常" };
            WEIGHT_ERRNO_ADD6 = new ERRNO() { Code = 15, Descrption = "No.6料斗加料异常" };

            WEIGHT_ERRNO_SCREWLACK = new ERRNO() { Code = 20, Descrption = "螺杆缺料报警" };
            WEIGHT_ERRNO_SCREWFLOW = new ERRNO() { Code = 21, Descrption = "螺杆流量超偏差报警" };
            WEIGHT_ERRNO_BLENDER = new ERRNO() { Code = 22, Descrption = "搅拌电机故障" };
            WEIGHT_ERRNO_SCRAM = new ERRNO() { Code = 23, Descrption = "急停开启" };
            WEIGHT_ERRNO_BLENDER2 = new ERRNO() { Code = 24, Descrption = "搅拌电机急停开启" };
            WEIGHT_ERRNO_BLENDER3 = new ERRNO() { Code = 25, Descrption = "搅拌电机未启动" };
        }

        /// <summary>
        /// PLC连接断开
        /// </summary>
        public static ERRNO ERRNO_PLC_DISCONNECTED;

        #region 单层报警类型
        /// <summary>
        /// No.1料仓缺料报警
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_LACK1;
        /// <summary>
        /// No.2料仓缺料报警
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_LACK2;
        /// <summary>
        /// No.3料仓缺料报警
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_LACK3;
        /// <summary>
        /// No.4料仓缺料报警
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_LACK4;
        /// <summary>
        /// No.5料仓缺料报警
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_LACK5;
        /// <summary>
        /// No.6料仓缺料报警
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_LACK6;
        /// <summary>
        /// No.1料斗加料异常
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_ADD1;
        /// <summary>
        /// No.2料斗加料异常
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_ADD2;
        /// <summary>
        /// No.3料斗加料异常
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_ADD3;
        /// <summary>
        /// No.4料斗加料异常
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_ADD4;
        /// <summary>
        /// No.5料斗加料异常
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_ADD5;
        /// <summary>
        /// No.6料斗加料异常
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_ADD6;
        /// <summary>
        /// 螺杆缺料报警
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_SCREWLACK;

        /// <summary>
        /// 螺杆流量超偏差报警
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_SCREWFLOW;

        /// <summary>
        /// 搅拌电机故障
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_BLENDER;

        /// <summary>
        /// 急停开启
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_SCRAM;

        /// <summary>
        /// 搅拌电机急停开启
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_BLENDER2;

        /// <summary>
        /// 搅拌电机未启动
        /// </summary>
        public static ERRNO WEIGHT_ERRNO_BLENDER3;
        #endregion
    }
}
