﻿using FLY.OBJComponents.Server.OBJProxy;
using FLY.Weight.Server.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Weight.Server.OBJProxy
{
    public class OBJProxy
    {
        WeightSystem_OBJProxy weightSystemOBJProxy;
        /// <summary>
        /// 流量
        /// </summary>
        Buffer_OBJProxy<Lc_Flow> mFlowListOBJProxy;
        /// <summary>
        /// 每次配料记录
        /// </summary>
        List<Buffer_OBJProxy<Lc_Mix>> mMixBufferOBJProxy = new List<Buffer_OBJProxy<Lc_Mix>>();
        /// <summary>
        /// 下辊时，总配料比例记录
        /// </summary>
        List<Buffer_OBJProxy<Lc_Mix>> mRollMixBufferOBJProxy = new List<Buffer_OBJProxy<Lc_Mix>>();

        WarningSystem_OBJProxy mWarnSystemOBJProxy;

        public OBJProxy(int objsys_idx, TDGage gage)
        {
            TDGage mGage = gage;
            weightSystemOBJProxy = new WeightSystem_OBJProxy(objsys_idx, gage.mData);

            mFlowListOBJProxy = new Buffer_OBJProxy<Lc_Flow>(
                objsys_idx,
                OBJ_INTERFACE.OBJ_INTERFACE.WEIGHTS_OBJ_FLOW_ID,
                gage.mHistoryDb.FlowBuffer);


            for (int i = 0; i < gage.mData.Items.Count(); i++)
            {
                mMixBufferOBJProxy.Add(
                    new Buffer_OBJProxy<Lc_Mix>(
                        objsys_idx,
                        OBJ_INTERFACE.OBJ_INTERFACE.WEIGHTS_OBJ_MIX_ID(i),
                        gage.mHistoryDb.MixBuffers[i]));

                mRollMixBufferOBJProxy.Add(
                    new Buffer_OBJProxy<Lc_Mix>(
                        objsys_idx,
                        OBJ_INTERFACE.OBJ_INTERFACE.WEIGHTS_OBJ_ROLLMIX_ID(i),
                        gage.mHistoryDb.RollMixBuffers[i]));
            }

            mWarnSystemOBJProxy = new WarningSystem_OBJProxy(
                objsys_idx,
                OBJ_INTERFACE.OBJ_INTERFACE.WARNING_OBJ_ID,
                gage.mWarning);

            weightSystemOBJProxy.CurrObjSys.Start_Conn_Server(
                new IPEndPoint(IPAddress.Any, gage.mSysParam.OBJ_Port), weightSystemOBJProxy.ID);
        }
    }
}
