﻿using FLY.OBJComponents.Server.Model;
using SQLite;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Weight.Server.Model
{
    /// <summary>
    /// 数据库对象
    /// </summary>
    public class DbModel:SQLiteDbContext,IErrorDBModel
    {
        /// <summary>
        /// Flow表 对象
        /// </summary>
        public DBTable<Db_Flow> TbFlow { get; } = new DBTable<Db_Flow>();

        /// <summary>
        /// Mix表 对象
        /// </summary>
        public DBTable<Db_Mix> TbMix { get; } = new DBTable<Db_Mix>();

        /// <summary>
        /// RollMix表 对象
        /// </summary>
        public DBTable<Db_RollMix> TbRollMix { get; } = new DBTable<Db_RollMix>();

        /// <summary>
        /// Error表 对象
        /// </summary>
        public DBTable<DB_Error> TbError { get; } = new DBTable<DB_Error>();

        /// <summary>
        /// 
        /// </summary>
        /// <param name="dbpath">sqlite数据库路径</param>
        public DbModel(string dbpath) : base(dbpath)
        {
            
        }
        /// <summary>
        /// 
        /// </summary>
        public DbModel() : this(@"D:\blowingdata\weight.sqlite3")
        {

        }
    }
}
