﻿using FLY.OBJComponents.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FLY.Winder.Common
{
    public static class ERRNOs
    {
        static ERRNOs()
        {
            ERRNO_PLC_DISCONNECTED = new ERRNO() { Code = 255, Descrption = "收卷 PLC连接断开" };

            #region 收卷
            ERRNO_WINDER_VFD = new ERRNO() { Code = 0, Descrption = "收卷变频故障报警", OffIsError = true };
            ERRNO_WINDER_FAN = new ERRNO() { Code = 1, Descrption = "收卷风机过载报警", OffIsError = true };
            ERRNO_WINDER_TURNOVER = new ERRNO() { Code = 2, Descrption = "收卷翻转刀架过载报警", OffIsError = true };
            ERRNO_WINDER_SCRAM = new ERRNO() { Code = 3, Descrption = "收卷急停开启", OffIsError = true };
            ERRNO_WINDER_AIRROLLERNOREADY = new ERRNO() { Code = 4, Descrption = "收卷换卷气涨轴检测未到位报警" };
            ERRNO_WINDER_MEASUREPREWARNING = new ERRNO() { Code = 5, Descrption = "收卷预警长度报警" };
            ERRNO_WINDER_CHANGEROLL = new ERRNO() { Code = 6, Descrption = "收卷换卷提醒报警" };
            ERRNO_WINDER_UNLOADARM = new ERRNO() { Code = 7, Descrption = "收卷卸料臂检测报警" };
            #endregion
            #region 其它
            ERRNO_TRACTION1FAN = new ERRNO() { Code = 20, Descrption = "主牵引风机过载报警", OffIsError = true };
            ERRNO_TRACTION1VFD = new ERRNO() { Code = 21, Descrption = "主牵引变频故障报警", OffIsError = true };
            ERRNO_TRACTION2VFD = new ERRNO() { Code = 22, Descrption = "二牵引变频故障报警", OffIsError = true };
            ERRNO_TRACTION2FAN = new ERRNO() { Code = 23, Descrption = "二牵引风机过载报警", OffIsError = true };
            ERRNO_ROTARYVFD = new ERRNO() { Code = 24, Descrption = "旋转塔变频故障报警", OffIsError = true };
            ERRNO_ROTARYFAN = new ERRNO() { Code = 25, Descrption = "旋转塔风机过载报警", OffIsError = true };
            ERRNO_TRACTION2SCRAM = new ERRNO() { Code = 26, Descrption = "二牵引拉线急停开启", OffIsError = true };
            ERRNO_SCRAM = new ERRNO() { Code = 27, Descrption = "电柜急停开启", OffIsError = true };
            ERRNO_TRACTION1SCRAM = new ERRNO() { Code = 28, Descrption = "主牵引拉线急停开启", OffIsError = true };
            ERRNO_CUSTOMERSCRAM = new ERRNO() { Code = 29, Descrption = "客户急停开启", OffIsError = true };
            ERRNO_ROTARYFORWLIMIT = new ERRNO() { Code = 30, Descrption = "旋转塔正转已到极限位", OffIsError = true };
            ERRNO_ROTARYBACKWLIMIT = new ERRNO() { Code = 31, Descrption = "旋转塔反转已到极限位", OffIsError = true };

            ERRNO_ROTARYFORWLOCK = new ERRNO() { Code = 32, Descrption = "转塔正向极限锁定" };
            ERRNO_ROTARYBACKWLOCK = new ERRNO() { Code = 33, Descrption = "转塔反向极限锁定" };

            #endregion
        }
        #region 报警类型
        /// <summary>
        /// PLC连接断开
        /// </summary>
        public static ERRNO ERRNO_PLC_DISCONNECTED;
        #region 内外收卷
        /// <SUMMARY>
        /// 收卷变频故障报警！！！请检查(OFF) ISERROR_VFD
        /// </SUMMARY>
        public static ERRNO ERRNO_WINDER_VFD;
        /// <SUMMARY>
        /// 收卷风机过载报警！！！请检查(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_WINDER_FAN;
        /// <SUMMARY>
        /// 收翻转刀架过载报警！！！请检查(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_WINDER_TURNOVER;
        /// <SUMMARY>
        /// 收卷急停开启！！！请复位(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_WINDER_SCRAM;
        /// <SUMMARY>
        /// 收卷换卷气涨轴检测未到位报警！！！请检查(ON)
        /// </SUMMARY>
        public static ERRNO ERRNO_WINDER_AIRROLLERNOREADY;
        /// <SUMMARY>
        /// 收预警长度报警！！！请准备换卷(ON)
        /// </SUMMARY>
        public static ERRNO ERRNO_WINDER_MEASUREPREWARNING;

        /// <SUMMARY>
        /// 收卷换卷提醒报警！！！请注意安全(ON)
        /// </SUMMARY>
        public static ERRNO ERRNO_WINDER_CHANGEROLL;

        /// <SUMMARY>
        /// 收卸料臂检测报警(ON)
        /// </SUMMARY>
        public static ERRNO ERRNO_WINDER_UNLOADARM;
        #endregion
        #region 其它

        /// <SUMMARY>
        /// 主牵引风机过载报警！！！请检查(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_TRACTION1FAN;

        /// <SUMMARY>
        /// 主牵引变频故障报警！！！请检查(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_TRACTION1VFD;

        /// <SUMMARY>
        /// 二牵引变频故障报警！！！请检查(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_TRACTION2VFD;

        /// <SUMMARY>
        /// 二牵引风机过载报警！！！请检查(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_TRACTION2FAN;

        /// <SUMMARY>
        /// 旋转塔变频故障报警！！！请检查(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_ROTARYVFD;

        /// <SUMMARY>
        /// 旋转塔风机过载报警！！！请检查(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_ROTARYFAN;

        /// <SUMMARY>
        /// 二牵引拉线急停开启！！！请复位(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_TRACTION2SCRAM;

        /// <SUMMARY>
        /// 电柜急停开启！！！请复位(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_SCRAM;

        /// <SUMMARY>
        /// 主牵引拉线急停开启！！！请复位(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_TRACTION1SCRAM;

        /// <SUMMARY>
        /// 客户急停开启！！！请复位(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_CUSTOMERSCRAM;

        /// <SUMMARY>
        /// 旋转塔正转已到极限位！！！请检查(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_ROTARYFORWLIMIT;

        /// <SUMMARY>
        /// 旋转塔反转已到极限位！！！请检查(OFF)
        /// </SUMMARY>
        public static ERRNO ERRNO_ROTARYBACKWLIMIT;

        /// <SUMMARY>
        /// 转塔正向极限锁定！！！请解除(ON)
        /// </SUMMARY>
        public static ERRNO ERRNO_ROTARYFORWLOCK;

        /// <SUMMARY>
        /// 转塔反向极限锁定！！！请解除(ON)
        /// </SUMMARY>
        public static ERRNO ERRNO_ROTARYBACKWLOCK;

        #endregion
        #endregion


    }
}
