﻿using SQLite;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Winder.Server.Model
{
    /// <summary>
    /// 收卷表
    /// </summary>
    [Table("WinderInfo")]
    public class Db_WinderInfo : IDbBase
    {
        [Key]
        [PropertyIndex(0)]
        public Int64 ID { get; set; }

        /// <summary>
        /// 时间
        /// </summary>
        [PropertyIndex(1)]
        public DateTime Time { get; set; }

        /// <summary>
        /// 线速度 m/min
        /// </summary>
        [PropertyIndex(2)]
        public double Velocity { get; set; }

        /// <summary>
        /// 上牵引电流   单位 A
        /// </summary>
        [PropertyIndex(2)]
        public double Traction1Current { get; set; }

        /// <summary>
        /// 二牵引电流   单位 A
        /// </summary>
        [PropertyIndex(3)]
        public double Traction2Current { get; set; }

        /// <summary>
        /// 内收卷电流   单位 A
        /// </summary>
        [PropertyIndex(4)]
        public double Winder0Current { get; set; }

        /// <summary>
        /// 外收卷电流   单位 A
        /// </summary>
        [PropertyIndex(5)]
        public double Winder1Current { get; set; }

        /// <summary>
        /// 二牵引实际张力 单位 Kg
        /// </summary>
        [PropertyIndex(6)]
        public double Traction2TensionKg { get; set; }

        /// <summary>
        /// 内收卷实际张力 单位 Kg
        /// </summary>
        [PropertyIndex(7)]
        public double Winder0TensionKg { get; set; }

        /// <summary>
        /// 外收卷实际张力 单位 Kg
        /// </summary>
        [PropertyIndex(8)]
        public double Winder1TensionKg { get; set; }

        /// <summary>
        /// 旋转塔电流 单位 A
        /// </summary>
        [PropertyIndex(9)]
        public double RotaryCurrent { get; set; }

        /// <summary>
        /// 旋转塔频率 单位 Hz
        /// </summary>
        [PropertyIndex(10)]
        public double RotaryFreq { get; set; }

        /// <summary>
        /// 旋转塔正转
        /// </summary>
        [PropertyIndex(11)]
        public bool IsRotaryForw { get; set; }

        /// <summary>
        /// 旋转塔反转
        /// </summary>
        [PropertyIndex(12)]
        public bool IsRotaryBackw { get; set; }

    }

}
