﻿using FLY.Winder.Server.OBJProxy;
using FLY.OBJComponents.Server.OBJProxy;
using FObjBase;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using FLY.Winder.Server.Model;
using FLY.OBJComponents.Server;

namespace FLY.Winder.Server
{
    public class TDGage
    {
        #region 初始化------------------------------------------------------------------
        public string mParamDirectory;//参数目录 m_path;//数据文件的 根目录默认是 Gage1
        public string mName;//名字 如:gage0
        #endregion

        public SysParam mSysParam;
        public WinderSystem mData;
        /// <summary>
        /// 报警系统
        /// </summary>
        public WarningSystem mWarning;

        public HistoryDb mHistoryDb;

        DbModel mDbModel;



        public TDGage(string nam)
        {
            mName = nam;
            mParamDirectory = mName;// @"D:\" + m_name;

            if (!System.IO.Directory.Exists(mParamDirectory))
            {
                System.IO.Directory.CreateDirectory(mParamDirectory);
            }
            System.Environment.CurrentDirectory = mParamDirectory;

            Init1();

        }
        #region Init登陆服务器初始化----------------------------------------------------
        /// <summary>
        /// 第1步, 加载本地数据
        /// </summary>
        public void Init1()
        {
            mSysParam = new SysParam();
            mData = new WinderSystem();

            //---------------------------------------------------------------------------------------------------------------
            //数据库
            mDbModel = new DbModel();
            mDbModel.Init();

            mHistoryDb = new HistoryDb();
            mHistoryDb.Init(mDbModel);
            mHistoryDb.KeepDBSize(mSysParam.DBKeepMonth);

            mWarning = new WarningSystem(mHistoryDb.ErrorBuffer);

            mData.Init(mHistoryDb, mWarning);


        }

        #endregion


    }
}
