﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using Microsoft.Win32;
using System.Threading;
using System.ComponentModel;

namespace Autogen_WS
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window,INotifyPropertyChanged
    {
        DataInfos di;
        public string XlsxPath
        {
            get;
            set;
        }
        public string CSharpPath
        {
            get;
            set;
        }
        
        public bool IsCreateCSharp
        {
            get;
            set;
        }


        public MainWindow()
        {
            
            InitializeComponent();

            di = new DataInfos();
            this.DataContext = di;
            grid_mainwindow.DataContext = this;


        }
        void Gen(object param) 
        {

            di.LoadXlsxFile();


            if (IsCreateCSharp)
            {
                #region 生成WeighterC属性代码
                di.Gen_CS();
                #endregion
            }
                #region 生成WS.xml

                di.Gen_WS_XML();

                #endregion
            


            this.Dispatcher.BeginInvoke(new Action(() =>
            {

                MessageBox.Show("完成");
            }), null);

        }
        private void button1_Click(object sender, RoutedEventArgs e)
        {
            FileInfo fi;

            try
            {
                fi = new FileInfo(XlsxPath);
            }
            catch
            {
                MessageBox.Show("请选择文件....", "Error");
                return;
            }
            if (!fi.Exists)
            {
                MessageBox.Show("文件不存在！", "Error");
                return;
            }

            if (IsCreateCSharp)
            {
                try
                {
                    fi = new FileInfo(CSharpPath);
                }
                catch
                {
                    MessageBox.Show("请选择.cs文件....", "Error");
                    return;
                }
                if (!fi.Exists)
                {
                    MessageBox.Show(".cs不存在！", "Error");
                    return;
                }
            }
            di.XlsxFile = XlsxPath;
            di.CSharpPath = CSharpPath;
            Thread t = new Thread(Gen);
            t.Start();
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "请选择HMI资源表";
            //ofd.InitialDirectory = @".";
            ofd.Filter = "excel文件(*.xlsx,*xlsm)|*.xlsx;*.xlsm";
            if (ofd.ShowDialog() == true)
            {
                XlsxPath = ofd.FileName;
            }
        }
        protected void NotifyPropertyChanged(string propertyname)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyname));
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;

        private void button4_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "请选择 WeightC.cs";
            //ofd.InitialDirectory = @".";

            ofd.Filter = "cs文件(*.cs)|*.cs";
            if (ofd.ShowDialog() == true)
            {
                CSharpPath = ofd.FileName;
            }
        }
    }
}
