﻿
using System.ComponentModel;

namespace FLY.Winder.Common
{
    public class WinderInsideOutside : INotifyPropertyChanged
    {

        #region 辅助代码生成
        /// <summary>
        /// 收卷实际m
        /// </summary>
        public float MeasureLen { get; set; }

        /// <summary>
        /// 收卷设定m
        /// </summary>
        public float MeasureLenSet { get; set; }

        /// <summary>
        /// 收卷预警m
        /// </summary>
        public float MeasurePreWarning { get; set; }

        /// <summary>
        /// 收卷计量关
        /// </summary>
        public bool MeasureStop { get; set; }

        /// <summary>
        /// 收卷计量清零(┷）
        /// </summary>
        public bool MeasureReset { get; set; }

        /// <summary>
        /// 收卷翻转点动(┷）
        /// </summary>
        public bool TurnoverInching { get; set; }

        /// <summary>
        /// 收卷切膜飞刀(┷）
        /// </summary>
        public bool CuttingFilm { get; set; }

        /// <summary>
        /// 收卷翻转原点(┷）
        /// </summary>
        public bool TurnoverOrg { get; set; }

        /// <summary>
        /// 收卷压臂平移(┷）
        /// </summary>
        public bool PressureArmOffset { get; set; }

        /// <summary>
        /// 收卷翻转上位等待(s)
        /// </summary>
        public float TurnoverUpperWait { get; set; }

        /// <summary>
        /// 收卷翻转原点延时(s)
        /// </summary>
        public float TurnoverOrgDelay { get; set; }

        /// <summary>
        /// 收卷翻转返回延时(s)
        /// </summary>
        public float TurnoverBackDelay { get; set; }

        /// <summary>
        /// 收卷锯齿切膜延时(s)
        /// </summary>
        public float CuttingFilmDelay { get; set; }

        /// <summary>
        /// 收卷锯齿切膜时间(s)
        /// </summary>
        public float CuttingFilmElapsed { get; set; }

        /// <summary>
        /// 收卷压臂返回时间(s)
        /// </summary>
        public float PressureArmBackElapsed { get; set; }

        /// <summary>
        /// 收卷气涨轴检测报警(s)
        /// </summary>
        public float AirRollerCheck { get; set; }

        /// <summary>
        /// 收卷一次平移时间(s)
        /// </summary>
        public float OffsetElapsed { get; set; }

        /// <summary>
        /// 收卷平移停顿时间(s)
        /// </summary>
        public float ElapsedWait { get; set; }

        /// <summary>
        /// 收卷接料限幅
        /// </summary>
        public float TapeLimit { get; set; }

        /// <summary>
        /// 收卷设定张力(kg)
        /// </summary>
        public float TensionKgSet { get; set; }

        /// <summary>
        /// 收卷实际张力(kg)
        /// </summary>
        public float TensionKg { get; set; }

        /// <summary>
        /// 收卷电机电流(A)
        /// </summary>
        public float Current { get; set; }

        /// <summary>
        /// 收卷手动
        /// </summary>
        public bool IsManual { get; set; }

        /// <summary>
        /// 收卷开启显示
        /// </summary>
        public bool IsOn { get; set; }

        /// <summary>
        /// 收卷开启设置
        /// </summary>
        public bool IsOnSet { get; set; }

        /// <summary>
        /// 收卷张力反馈
        /// </summary>
        public float Tension { get; set; }

        /// <summary>
        /// 收卷张力设定
        /// </summary>
        public float TensionSet { get; set; }

        /// <summary>
        /// 收卷增益设定
        /// </summary>
        public float Gain { get; set; }

        /// <summary>
        /// 收卷积分时间
        /// </summary>
        public float ITime { get; set; }

        /// <summary>
        /// 收卷调节系数
        /// </summary>
        public float Factor { get; set; }

        /// <summary>
        /// 收卷辊筒直径
        /// </summary>
        public float RollerD { get; set; }

        /// <summary>
        /// 收卷传动速比
        /// </summary>
        public float GearRatio { get; set; }

        /// <summary>
        /// 收卷PID结果
        /// </summary>
        public float PIDResult { get; set; }

        /// <summary>
        /// 收卷PID调节
        /// </summary>
        public float PIDAdjust { get; set; }

        /// <summary>
        /// 收卷同步速度
        /// </summary>
        public float SyncV { get; set; }

        /// <summary>
        /// 收卷实际速度
        /// </summary>
        public float Velocity { get; set; }

        /// <summary>
        /// 收卷升降增益
        /// </summary>
        public float LiftGain { get; set; }

        /// <summary>
        /// 收卷速度补偿
        /// </summary>
        public float VelocityComp { get; set; }

        /// <summary>
        /// 收卷变频故障报警！！！请检查(OFF)
        /// </summary>
        public bool IsError_VFD { get; set; }

        /// <summary>
        /// 收卷风机过载报警！！！请检查(OFF)
        /// </summary>
        public bool IsError_Fan { get; set; }

        /// <summary>
        /// 收翻转刀架过载报警！！！请检查(OFF)
        /// </summary>
        public bool IsError_Turnover { get; set; }

        /// <summary>
        /// 收卷急停开启！！！请复位(OFF)
        /// </summary>
        public bool IsError_Scram { get; set; }

        /// <summary>
        /// 收卷换卷气涨轴检测未到位报警！！！请检查(ON)
        /// </summary>
        public bool IsError_AirRollerNoReady { get; set; }

        /// <summary>
        /// 收预警长度报警！！！请准备换卷(ON)
        /// </summary>
        public bool IsError_MeasurePreWarning { get; set; }

        /// <summary>
        /// 收卷换卷提醒报警！！！请注意安全(ON)
        /// </summary>
        public bool IsError_ChangeRoll { get; set; }

        /// <summary>
        /// 收卸料臂检测报警(ON)
        /// </summary>
        public bool IsError_UnloadArm { get; set; }

        #endregion
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
