﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace FLY.Weight.Common
{
    public class WeighterAccessory:INotifyPropertyChanged
    {
        #region 辅助代码生成
        /// <summary>
        /// 总流量设定
        /// </summary>
        public float TotalFlowSetting { get; set; }

        /// <summary>
        /// 总流量显示
        /// </summary>
        public float TotalFlow { get; set; }

        /// <summary>
        /// 总产量
        /// </summary>
        public float TotalProduction { get; set; }

        /// <summary>
        /// 码轮周长mm
        /// </summary>
        public float WheelPerimeter { get; set; }

        /// <summary>
        /// 码轮脉冲
        /// </summary>
        public float WheelPulse { get; set; }

        /// <summary>
        /// 平均密度
        /// </summary>
        public float Density { get; set; }

        /// <summary>
        /// 边料不回收
        /// </summary>
        public bool IsRimNoRecycle { get; set; }

        /// <summary>
        /// 边料kg/h
        /// </summary>
        public float RimCharge { get; set; }

        /// <summary>
        /// 厚度um
        /// </summary>
        public float Thickness { get; set; }

        /// <summary>
        /// 当前线速度m/min
        /// </summary>
        public float CurrentVelocity { get; set; }

        /// <summary>
        /// 当前线速度设置m/min
        /// </summary>
        public float CurrentVelocitySet { get; set; }

        /// <summary>
        /// 吹膜宽度mm
        /// </summary>
        public float TotalFilmWidth { get; set; }

        /// <summary>
        /// 切边mm
        /// </summary>
        public float RimWidth { get; set; }

        /// <summary>
        /// 收卷宽度mm
        /// </summary>
        public float ActFilmWidth { get; set; }

        /// <summary>
        /// 设定厚度um
        /// </summary>
        public float SetThickness { get; set; }

        /// <summary>
        /// 理论速度m/min
        /// </summary>
        public float TargetVelocity { get; set; }

        /// <summary>
        /// 内收卷当前m
        /// </summary>
        public float ACurrentLen { get; set; }

        /// <summary>
        /// 内收卷当前kg
        /// </summary>
        public float ACurrent { get; set; }

        /// <summary>
        /// 内收卷上卷kg
        /// </summary>
        public float ALast { get; set; }

        /// <summary>
        /// 外收卷当前m
        /// </summary>
        public float BCurrentLen { get; set; }

        /// <summary>
        /// 外收卷当前kg
        /// </summary>
        public float BCurrent { get; set; }

        /// <summary>
        /// 外收卷上卷kg
        /// </summary>
        public float BLast { get; set; }

        /// <summary>
        /// 内收卷清零
        /// </summary>
        public bool AClear { get; set; }

        /// <summary>
        /// 外收卷清零
        /// </summary>
        public bool BClear { get; set; }

        #endregion
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
