﻿using OfficeOpenXml;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace Autogen_WS
{
    public class DeviceAddr
    {
        public List<string> EP = new List<string>();

        /// <summary>
        /// 读取设备转换表
        /// </summary>
        /// <returns></returns>
        public bool Load(string xlsxfile)
        {
            EP.Clear();


            int i_deviceno = 1;//设备序号
            int i_ep = 2;//ep
            
            
            using (ExcelPackage packages = new ExcelPackage(new FileInfo(xlsxfile)))
            {
                using (ExcelWorksheet sheet = packages.Workbook.Worksheets["设备地址"])
                {
                    int iRow = 2;
                    int i = iRow - 1;
                    while (true)
                    {
                        i++;
                        string str_dev;
                        string str_ep;
                        try
                        {
                            str_dev = sheet.Cells[i, i_deviceno].Value.ToString();
                            str_ep = sheet.Cells[i, i_ep].Value.ToString();
                        }
                        catch
                        {
                            //完成，没有数据了
                            break;
                        }

                        if (string.IsNullOrEmpty(str_dev)) break;

                        EP.Add(str_ep);

                    }
                }
            }
            if (EP.Count == 0)
                return false;
            return true;
        }
    }
}
