﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;

namespace Autogen_WS
{
    /// <summary>
    /// 加载通讯列表用， 保存的 WS.xml 文件！！！！
    /// </summary>
    public class PLCGroup
    {
        public class PLCDevice
        {
            public IPEndPoint EP { get; set; }
        }

        public class PLCVariable
        {
            /// <summary>
            /// 设备序号
            /// </summary>
            public int DeviceIndex { get; set; }
            /// <summary>
            /// 0,1,3,4
            /// </summary>
            public string Mode { get; set; }
            /// <summary>
            /// 地址
            /// </summary>
            public int Addr { get; set; }
            /// <summary>
            /// 类型 只有 bool 才对应 bool， 其它数值类型 都转为 float
            /// </summary>
            public string Type { get; set; }
            /// <summary>
            /// 放大倍数
            /// </summary>
            public double Scale { get; set; }
            /// <summary>
            /// 属性拥有者名称
            /// </summary>
            public string OwnerName { get; set; }
            /// <summary>
            /// 属性名称
            /// </summary>
            public string PropertyName { get; set; }
        }


        public List<PLCDevice> Devices = new List<PLCDevice>();
        public List<PLCVariable> Variables = new List<PLCVariable>();


        public void Load(string filepath)
        {
            Misc.SaveToXmlHepler.Load(filepath, this);
        }
        public void Save(string filepath) 
        {
            Misc.SaveToXmlHepler.Save(filepath, this);
        }
    }
}
