﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Autogen_WS
{
    public class WS_ItemInfo
    {
        /// <summary>
        /// 属性名
        /// </summary>
        public string propName;
        /// <summary>
        /// 属性描述
        /// </summary>
        public string propDescription;

        /// <summary>
        /// plc 序号
        /// </summary>
        public int plc_index = 0;
        /// <summary>
        /// 寄存器类型 0,1,3,4
        /// </summary>
        public string reg_type;
        /// <summary>
        /// 地址
        /// </summary>
        public int mb_addr = -1;

        /// <summary>
        /// 数据类型， 与寄存器类型不同, bool, float, UInt16
        /// </summary>
        public string typeName;
        /// <summary>
        /// 放大
        /// </summary>
        public double scale = 1;

        /// <summary>
        /// 对象名
        /// </summary>
        public string objectName;

        public WS_ItemInfo()
        { }

        public WS_ItemInfo Clone()
        {
            WS_ItemInfo ii = new WS_ItemInfo();
            ii.propName = propName;
            ii.propDescription = propDescription;
            ii.plc_index = plc_index;
            ii.reg_type = reg_type;
            ii.mb_addr = mb_addr;
            ii.typeName = typeName;
            ii.scale = scale;
            ii.objectName = objectName;
            return ii;
        }

        public string GetPropertyType()
        {
            if (typeName == "bool")
                return "bool";
            else
                return "float";
        }
    }
}
